;===========================
; 2002.4.1 . recursive FLOAD ok
;            . PACK$ adds null byte and the end
;            . TYPE, EMIT will reset caret to end of text before output
;            . add Null terminator for NAME field and D$ 
;            
; 2002.4.2
;            . fix doCALLBACK , create private data stack for callbacks to prevent 
;              possible destruction of windows return stack
;            . when FLOAD has error, print line number and switch to intepreter.
;            . fix HostType , null terminator patch
;            . normal CALL instead of DD follows COMPILE    ( suggested by Sam, fixed by Ting )
;            . add 2/ 2* lshift rshift
;           
; 2002.4.3 -- 2.0.1
;            . add FORGET,FENCE,EMPTY,ANEW to start.f
;            . CAP CAPS  
;            . FIND support case insensitive search
;            . force case sensitive in NAME? to avoid redef warning
; 2002.4.4 -- 2.0.2
;            . to avoid messing up with uppercase, introduce new runtime routine convention: 
;            . change abort" to doABORT"
;            . change next   to doNEXT
;            . change parse  to doPARSE
; 2002.4.9
;            . remove menu
;            . fix find , abort when voc is zero
;            . add text output buffer, remove HostType, add HostFlush
; 2002.4.10 
;            . perform pointer checking for ! @ C! C@ FILL CMOVE EXECUTE @EXECUTE
;            . fixed $,n when no name
;
; 2002.4.11  - 2.03
;            . dofload accept zstring , 
;            . add ZCOUNT

; TODO
;            . message cracker
;            . Editor window , compile in memory text string, stop at error line
;            . stack window  

.386
.model  flat, stdcall
option  casemap:none

    include     c:\masm32\include\windows.inc
    include     c:\masm32\include\kernel32.inc
    include     c:\masm32\include\user32.inc
    include     c:\masm32\include\gdi32.inc
    include     c:\masm32\include\comctl32.inc
	include     c:\masm32\include\comdlg32.inc

    includelib  c:\masm32\lib\kernel32.lib
    includelib  c:\masm32\lib\user32.lib
    includelib  c:\masm32\lib\gdi32.lib
    includelib  c:\masm32\lib\comctl32.lib
	includelib  c:\masm32\lib\comdlg32.lib

	WinMain proto :DWORD, :DWORD, :DWORD, :DWORD
	ForthProc PROTO 
	GrandDictionaryWrite PROTO 
	GetModuleBaseName PROTO :DWORD, :DWORD, :DWORD, :DWORD

.const

.data


	lastkey         dd 0
	EditClass       db "EDIT",0 
    Editor          db 8,"THISEDIT",0
	HelpMe          db 4,"HELP",0
    StatClass      db  'msctls_statusbar32',0

    hIcon         	dd 0
 	RP0           	dd 0                   ; return stack 

	UPP           	dd offset UZERO
              		dd 1000H DUP (0)
	DATASTACK     	dd 0
                    dd 1000H DUP (0)
    CB_DATASTACK    dd 0                    ; return stack for callback
	startupfile     db 256 DUP(0)
	floadbuf        dd 0  ; pointer to fload buffer
	floadused       dd 0  ; floadbuf used byte
	floadlen        dd 200000H  ; length of floadbuf
	floaddepth      dd 0
	filesize        dd 0
	filehandle      dd 0

	ClassName       db  "WFClass", 0
	AppName         db  "WeForth Console", 0

	linebuffer      db 1000H DUP(0)
	linebufferlen   dd 0
	

szFilter       db  'All Files',0,'*.*',0,0
szOpenTitle    db  'Open File',0
.data?

	hInstance       dd  ?
	hwndEdit        dd  ?
	hwnd            dd  ?
	OldWndProc      dd  ? 
	readbyte        dd  ?
    nullterminator  dd  ?

PathName       db  256 dup(?)
WorkBuff       db  256 dup(?)
FileName       db  64  dup(?)

.code

$POP_EBX MACRO
   mov   ebx,[ebp]
   lea   ebp,[ebp+4]
ENDM

$PUSH_EBX MACRO
   lea   ebp,[ebp-4]
   mov   [ebp],ebx
ENDM

; use this before calling forth word from windows
$ENTER_SYSTEM MACRO
    push    ebp                 ; save ebp
    lea     eax, SPZERO
    lea     ebp, CB_DATASTACK   ; data stack for callback
	mov     [eax], ebp          ; adjust SPZERO
ENDM

$LEAVE_SYSTEM MACRO
    lea     eax, SPZERO
    lea     ebp, DATASTACK
	mov     [eax], ebp
    pop     ebp
ENDM

start:

    invoke  GetModuleHandle, NULL
    mov     hInstance,eax

	lea     edi, startupfile
	;inc     edi


	invoke GetCurrentDirectory, 248,edi
	add    edi, eax
	mov    eax, 'ats\'
	mov    [edi],eax
	mov    eax, 'f.tr'
	mov    [edi+4], eax
	


WinMain proc hInst :DWORD, hPrevInst :DWORD,
                CmdLine :DWORD, CmdShow :DWORD

    LOCAL wc :WNDCLASSEX, msg :MSG
LOCAL    ofn:OPENFILENAME


    mov     wc.cbSize, SIZEOF WNDCLASSEX
    mov     wc.style, CS_HREDRAW or CS_VREDRAW
    mov     wc.lpfnWndProc, OFFSET WndProc
    mov     wc.cbClsExtra, NULL
    mov     wc.cbWndExtra, NULL

    push    hInst
    pop     wc.hInstance

    mov     wc.hbrBackground, COLOR_WINDOW+1
    mov     wc.lpszClassName, OFFSET ClassName

    invoke  LoadIcon, NULL, 500
    mov     wc.hIcon, eax
    mov     wc.hIconSm, eax

    invoke  LoadCursor, NULL, IDC_ARROW
    mov     wc.hCursor, eax

    invoke  RegisterClassEx, addr wc

    invoke  CreateWindowEx, WS_EX_ACCEPTFILES, ADDR ClassName,
                ADDR AppName, WS_OVERLAPPEDWINDOW, CW_USEDEFAULT,
                CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
                NULL, NULL, hInst, NULL

    mov     hwnd, eax

    invoke ShowWindow, hwnd, SW_SHOWNORMAL
    invoke UpdateWindow, hwnd
    
    invoke GrandDictionaryWrite

; export variable to Forth
    lea esi , HINST_
	mov eax, hInstance
	mov [esi], eax

	lea esi, HWND_
	mov eax, hwnd
	mov [esi], eax

	lea esi, HWNDCONSOLE_
	mov eax, hwndEdit
	mov [esi], eax

	; forth entry point
    invoke GlobalAlloc,GPTR, floadlen
	mov floadbuf,eax

    lea esi, FLOADBUF_
	mov [esi], eax

    invoke ForthProc              
    invoke InitCommonControls 
    ret

WinMain endp


GrandDictionaryWrite proc      ; make dictionary writable
	  LOCAL oldprotect :DWORD;

	  lea eax, UZERO
	  lea ebx, DICTEND
	  sub ebx, eax

	  invoke VirtualProtect , ADDR start, ebx, PAGE_EXECUTE_READWRITE , ADDR oldprotect
      ret
GrandDictionaryWrite endp


ToEditor proc    ; switch to editor
    $ENTER_SYSTEM
    $PUSH_EBX
	lea ebx, Editor             ; fetch forth editor variable 
	call NAMEQ
	or  ebx,ebx
    jz ToEditor1                ; variable not defined

    $POP_EBX
	add ebx,5
    mov ebx, [ebx]
	or  ebx, ebx
	jz ToEditor1                ; variable is zero

    invoke SetFocus,ebx

ToEditor1:  
	$POP_EBX
	$POP_EBX
    $LEAVE_SYSTEM
	ret

ToEditor endp

EditWndProc PROC hEdit:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD 
    

    .if uMsg==WM_CHAR 
        mov eax,wParam 
		cmp eax, 18H    ; control X
		je default
		cmp eax, 16H    ; control V
		je CTRLV
		cmp eax, 03H    ; control C
		je default

		cmp eax, 01H    ; control A
		je selectall

		mov lastkey,eax
		xor eax,eax
        ret

    .endif

	.if uMsg==WM_KEYUP
	    .if wParam==78H   ; switch to editor
            call ToEditor
		.endif
	.endif
    jmp default

selectall:
    invoke CallWindowProc,OldWndProc,hEdit,EM_SETSEL,0,-1
	ret
default:
    invoke CallWindowProc,OldWndProc,hEdit,uMsg,wParam,lParam 
    ret 

CTRLV:

    call HostFlush
	invoke CallWindowProc,OldWndProc,hEdit,WM_GETTEXTLENGTH,0,0
    mov esi, eax
    invoke CallWindowProc,OldWndProc,hEdit,uMsg,wParam,lParam     ; paste text
    invoke CallWindowProc,OldWndProc,hEdit,WM_GETTEXTLENGTH,0,0
    mov edi, eax
	sub edi, esi

    invoke OpenClipboard, 0
	invoke GetClipboardData, CF_OEMTEXT
	invoke RtlMoveMemory, floadbuf, eax, edi
	invoke CloseClipboard

    $ENTER_SYSTEM
	$PUSH_EBX
	lea ebx,floadbuf  ; begin of buffer
	mov ebx,[ebx]
	$PUSH_EBX
	mov ebx, edi      ; end of buffer


	CALL BLOAD
    $POP_EBX
	$POP_EBX

	$LEAVE_SYSTEM
	ret
EditWndProc endp 

CleanUp proc
    .if floadbuf!=0 
	  invoke GlobalFree, floadbuf
	.endif
	ret
CleanUp endp

WndProc proc hWnd :DWORD, uMsg :DWORD, wParam :DWORD, lParam :DWORD

    LOCAL chrg  :CHARRANGE

    .if uMsg==WM_CREATE

        invoke  CreateWindowEx, 0 , ADDR EditClass, 0,  ; WS_EX_CLIENTEDGE
                WS_CHILD+WS_VISIBLE+ES_MULTILINE+WS_VSCROLL+ES_NOHIDESEL,
                CW_USEDEFAULT,CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
                hWnd, 0, hInstance, NULL


        mov hwndEdit, eax
        invoke SendMessage, hwndEdit, EM_EMPTYUNDOBUFFER, 0, 0
        invoke GetStockObject,SYSTEM_FIXED_FONT
        invoke SendMessage,hwndEdit,WM_SETFONT,eax,0
        invoke SendMessage,hwndEdit,EM_LIMITTEXT,0FFFFFFFFH,0

        invoke SetWindowLong,hwndEdit,GWL_WNDPROC,addr EditWndProc 
        mov OldWndProc,eax   
       
 
	.elseif uMsg==WM_ACTIVATE
        invoke SetFocus, hwndEdit		

    .elseif uMsg==WM_COMMAND

    .elseif uMsg == WM_CLOSE
         invoke DestroyWindow, hWnd

    .elseif uMsg == WM_SIZE

        mov eax, lParam
        mov edx, eax
        and eax, 0FFFFh
        shr edx, 16
        invoke  MoveWindow, hwndEdit, 0, 0, eax, edx, TRUE

    .elseif uMsg == WM_DESTROY
        invoke  PostQuitMessage, NULL
		; this line should be removed if forth BYE  call ExitProcess
		invoke CleanUp
        invoke ExitProcess,0

    .else

        invoke  DefWindowProc, hWnd, uMsg, wParam, lParam
        ret

    .endif

    xor eax, eax

    ret


WndProc endp



; KEY or ACCEPT must call HostProcessMessage 
; msg MSG <>

HostProcessMessage proc
LOCAL msg:MSG
    call   HostFlush
    invoke GetMessage, ADDR msg, 0, 0, 0

    cmp eax,0
    je ExitProcessMessage

    invoke TranslateMessage, ADDR msg
    invoke DispatchMessage, ADDR msg
	mov eax,1

ExitProcessMessage:
	ret
HostProcessMessage endp

GetEditLength proc
  push ebx
  invoke CallWindowProc, OldWndProc,hwndEdit, EM_GETLINECOUNT,0,0
  dec eax
  invoke CallWindowProc, OldWndProc,hwndEdit, EM_LINEINDEX,eax,0
  mov ebx, eax
  invoke CallWindowProc, OldWndProc,hwndEdit, EM_LINELENGTH, eax, 0
  add eax,ebx
  pop ebx
  ret

GetEditLength endp


HostFlush proc
  
  mov   eax, linebufferlen
  or    eax, eax
  jz    HostFlush1

  lea   esi, linebuffer
  add   esi, linebufferlen
  mov   eax, [esi]
  mov   nullterminator, eax

  xor   eax,eax                ; null terminator
  mov   [esi],eax

  invoke CallWindowProc,OldWndProc,hwndEdit,WM_GETTEXTLENGTH,0,0
  invoke CallWindowProc,OldWndProc,hwndEdit,EM_SETSEL,eax,eax
  invoke CallWindowProc, OldWndProc,hwndEdit, EM_REPLACESEL,0, ADDR linebuffer

; restore null terminator
  lea   esi, linebuffer
  add   esi, linebufferlen
  mov   eax,nullterminator
  mov   [esi], eax

  xor   eax,eax
  mov   linebufferlen, eax

HostFlush1:
  ret
HostFlush endp


HostEmit proc
  cmp   ebx, 20H
  jl    HostEmit2
  
  lea   esi, linebufferlen
  mov   esi,[esi]
  cmp   esi, 1000H
  jl    HostEmit1
  call  HostFlush

HostEmit1:

  lea   esi, linebuffer
  add   esi, linebufferlen
  mov   [esi], ebx
  inc   linebufferlen

  $POP_EBX
  ret

HostEmit2:
  invoke HostFlush
  invoke CallWindowProc,OldWndProc,hwndEdit,WM_GETTEXTLENGTH,0,0
  invoke CallWindowProc,OldWndProc,hwndEdit,EM_SETSEL,eax,eax
  invoke CallWindowProc,OldWndProc,hwndEdit,WM_CHAR,ebx,0
  $POP_EBX

  ret
HostEmit endp

HostKeyq proc 
         xor eax,eax
         mov eax,lastkey
         ret
HostKeyq endp

HostCreateFile proc  ; file name in ebx
         invoke CreateFile, ebx , GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,NULL
		 ret
HostCreateFile endp


HostCloseFile proc handle:DWORD
  invoke CloseHandle,handle
  ret
HostCloseFile endp

ForthProc proc 
  push ebp
  mov  ebp, offset DATASTACK
  mov  UPP, offset UZERO
	  
  mov  RP0, esp
  call COLD
  pop ebp

ForthProc endp

;======================FORTH AREA====================================
UZERO:
;	include ef502.asm
;========================================EF502================================================================================

; # EForth
;===============================================================
;       486 eForth 4.03 by C. H. Ting, 1996, July 26
;       To replace BIOS ROM. Unsuccessful.

;       486 eForth 4.02 by C. H. Ting, 1996, June 28
;       OK402.ASM ported from Chuck Moore's HELLO.COM
;       EF402.ASM loaded with OK402.ASM
;               >masm ok402,,,,
;               >masm ef402,,,,
;               >link ok402 ef402,,,,
;       Resulting OK402.EXE put eForth at a wrong location 5F0H.
;       It must be moved to 300H using CV
;               >cv ok402
;               >n16
;               >r ds 50e7      align ds to cs
;               >m 5f0 l 4000 300
;               >g
;       OK402.EXE thus fixed will jump to eForth in 32-bit protected
;       mode under DOS.

;       486 EfORTH 4.01 by C. H. Ting, 1996
;       32-bit eForth, protected mode under Chuck Moore's OK
;       Strip first 300H bytes from EF401.EXE to make EF401.COM
;       Under OK type:
;               >load EF401.COM
;               >debug HELLO32.COM
;               -g
;       4.01 is running from 110000H as logical 0.
;       HELLO32.COM is derived from Chuck's HELLO.COM except
;       in 32-bit mode with 32-bit flat address.
;
;       386 eForth 3.01 by C. H. Ting, 1996
;       16-bit protected mode to be used with Chuck Moore's OK.
;
;       8086 eForth 2.02 by C. H. Ting, 1996
;       Fully optimized by recoding most common functions in code.
;               Add doUSE, doVAR, and doCON in code.
;
;       8086 eForth 2.01 by C. H. Ting, 1996
;       To be committed to Boot ROM on a standard PC motherboard.
;       !IO,?RX and TX! access COM1 port directly, 9600-8-1-n.
;       16KB of ROM from FC000 to FFFFF.  CS is set to FC00 upon booting.
;       Stacks and user area just below 5000, physically below 01000.
;       Code dictionary from 5000 up, name dictionary from FFF0 down.
;       Working under DOS, 27may96cht
;               8K ROM starting FE000.
;               Add VFORTH for ROMmability. 30may96cht
;
;       386 eForth 1.1 by C. H. Ting, 1992 with Al Williams' DOS
;               extender.
;
;       Much of the code is derived from the following sources: ;
;       8086 eForth 1.0 by Bill Muench and C. H. Ting, 1990
;       8086 figForth by Thomas Newman, 1981 and Joe smith, 1983
;       aFORTH by John Rible, 1988
;       bFORTH by Bill Muench, 1989
;
;       Step towards this 386 eForth:
;       Incorporate Ken Chen's DIAGNOSE. 3/2/92 cht     ef1
;       Compile eForth with 32 bit cells. 3/15/92 cht.  ef2
;       Names are changed to 32 bit cells. 3/16/92 cht. ef3
;       All cells are changed to 32 bits. 3/20/92 cht.  ef4
;       Protected mode, separated stack. 4/17/92 cht    ef6
;       Get ok, interpreter works. 4/24/92 cht.         ef8
;       Compiler ok. 4/25/92 cht
;
;===============================================================

;; Version control

VER             EQU     2H                      ;major release version
EXT             EQU     3H                      ;minor extension

;; Constants

COMPO           EQU     040H                    ;lexicon compile only bit
IMEDD           EQU     080H                    ;lexicon immediate bit
MASKK           EQU     0FF1FH                  ;lexicon bit mask  ; change from 7F1F to FF1F to adopt chinese

CELLL           EQU     4                       ;size of a cell
BASEE           EQU     10                      ;default radix
VOCSS           EQU     8                       ;depth of vocabulary stack

BKSPP           EQU     8                       ;backspace
LF              EQU     10                           ;line feed
CRR             EQU     13                      ;carriage return
ERR             EQU     27                      ;error escape
TIC             EQU     39                      ;tick

CALLL           EQU     0E8H    ; call opcode
RETT		EQU	0C3H	; ret opcode

;; Memory allocation    0//code>--//--<name//up>--<sp//tib>--rp//em



;; Initialize assembly variables

_LINK   = 0                                     ;force a null link
_USER   = 4*CELLL                               ;first user variable offset

;; Define assembly macros

;       Compile a code definition header.

$CODE   MACRO   LEX,NAME,LABEL
	DD      _LINK                    ;;token pointer and link$$$$$$
	_LINK   = $        ;;new header on cell boundary
	DB      LEX,NAME,0                        ;;name string
LABEL:                                          ;;assembly label
	ENDM

;       Compile a colon definition header.

$COLON  MACRO   LEX,NAME,LABEL
	$CODE   LEX,NAME,LABEL
	ENDM

;       Compile a user variable header.

$USER   MACRO   LEX,NAME,LABEL
	$CODE   LEX,NAME,LABEL
	CALL    DOUSE                           ;;include CALL doLIST
	DD      _USER                     ;;followed by doUSER and offset
	_USER   = _USER+CELLL                   ;;update user area offset
	ENDM

;       Compile an inline string.

D$      MACRO   funct,string
      	call   funct
      	db     (@f-$-2),string , 0
@@:
        ENDM

;       Assemble inline direct threaded code ending.

$NEXT   MACRO
	RET
	ENDM


$BRAN   MACRO    BRAADR2 ; BRANCH macro
        jmp      BRAADR2
        ENDM

$QBRAN  MACRO    BRAADR0   ; ?0BRANCH macro
        ;call     QBRAN
        ;DD       BRAADR0
		or       ebx,ebx
        $POP_EBX
		jz       BRAADR0
        ENDM

$NEXT   MACRO    LPADR ; NEXT MACRO
        call     DONXT
        DD       LPADR
        ENDM

;; Main entry points and COLD start data



; COLD start moves the following to USER variables.
; MUST BE IN SAME ORDER AS USER VARIABLES.

; UZERO:          
		DD      0               	;reserved
		DD	0
		DD	0
		DD	0
SPZERO:
		DD      DATASTACK               ;SP0
		DD      RP0                     ;RP0
		DD      QRX                     ;'?KEY
		DD      TXSTO                   ;'EMIT
		DD      ACCEP                   ;'EXPECT
		DD      KTAP                    ;'TAP
		DD      TXSTO                   ;'ECHO
		DD      DOTOK                   ;'PROMPT
		DD      BASEE                   ;BASE
		DD      0                       ;tmp
		DD      0                       ;SPAN
INN_:
		DD      0                       ;>IN
NTIB_:
		DD      0                       ;#TIB
		DD      TIBB                    ;TIB
		DD      0                       ;CSP
		DD      INTER                   ;'EVAL
		DD      NUMBQ                   ;'NUMBER
		DD      0                       ;HLD
		DD      0                       ;HANDLER
		DD      0                       ;CONTEXT pointer
		DD      VOCSS DUP (0)           ;vocabulary stack
		DD      0                       ;CURRENT pointer
		DD      0                       ;vocabulary link pointer
HERE_:
		DD      CTOP                    ;CP
		DD      CTOP                    ;NP
		DD      LASTN                   ;LAST


;============================WEFORTH=============================================
CAP_:
        DD      0                       ; case insensitive
HINST_:
        DD      0                       ; app instance
HWND_:
        DD      0                       ; main window handle
HWNDCONSOLE_:
        DD      0
DICTEND_:
        DD      DICTEND
FLOADBUF_:
        DD      0
ULAST:
US              DD     	200H DUP (0)                ;user area size in cells
RTS             DD     	200H DUP (0)                ;return stack/TIB size

; return stack provided by Windows
;RPP             DD     	200H DUP (0)                  ;start of return stack (RP0)
TIBB            DD     	200H DUP (0)                   ;terminal input buffer (TIB)
SPP             DD     	200H DUP (0)                 ;start of data stack (SP0)

;ORG     CODEE                                   ;start code dictionary

;; Device dependent I/O

    $CODE       3,'GPF', GPF     ; ( a -- )       
	    call    BASE
		call    AT
		call    TOR
		call    HEX
		call    BDIGS
        call    DIGS
		call    DOLIT
		DD      'x'
		call    HOLD

		CALL    DOLIT
		DD     '0'
		call    HOLD
        call    EDIGS
; set count byte
        CALL    OVER
		CALL    ONEM
		CALL    CSTOR
		CALL    ONEM

		call    RFROM
		call    BASE
		call    STORE

	    D$      DOTQP,  " Invalid Pointer:" 

   		CALL    THROW
		ret


;   BYE         ( -- )
;               Exit eForth.

		$CODE   3,'BYE',BYE
		invoke SendMessage, hwnd, WM_CLOSE, 0,0
		ret

;   ?RX         ( -- c T | F )
;               Return input character and true, or a false if no input.

		$CODE   3,'?RX',QRX
		invoke HostKeyq
		$PUSH_EBX
		mov ebx,eax
		cmp ebx,0
		je  RX1
		  $PUSH_EBX
		  mov ebx,-1
		RX1:
		ret
		

;   TX!         ( c -- )
;               Send character c to the output device.

		$CODE   3,'TX!',TXSTO
		call HostEmit
                ret

;   !IO         ( -- )
;               Initialize the serial I/O devices.

		$CODE   3,'!IO',STOIO
		RET


;; The kernel

;   doLIT       ( -- w )
;               Push an inline literal.

		$CODE   COMPO+5,'doLIT',DOLIT
	    $PUSH_EBX
		pop      eax
		mov      ebx,[eax]
		add      eax,4
		push     eax
		ret

;   EXIT        ( -- )
;               Terminate a colon definition.

		$CODE   4,'EXIT',EXIT
		call    RFROM
		call    DROP
		ret

;   EXECUTE     ( ca -- )
;               Execute the word at ca.

		$CODE   7,'EXECUTE',EXECU
        invoke  IsBadCodePtr, ebx
        or      eax,eax
  		jnz     GPF

       	mov     eax,ebx     
       	$POP_EBX
		jmp     eax

;   next        ( -- )
;               Run time code for the single index loop.
;               : next ( -- ) \ hilevel model
;                 r> r> dup if 1 - >r @ >r exit then drop cell+ >r ;

		$CODE   COMPO+4,'doNEXT',DONXT
	    	pop     eax
		sub     dword ptr [esp],1
		jc      nexta
        	jmp     dword ptr [eax]           ; jump back toLOOPP starting point
nexta:                                    ; LOOPP is ending,LOOPP counter do not push back
        	add     eax, 4
		pop     ecx
        	jmp     eax                       ; continue from next entry by skipping a word

;   ?branch     ( f -- )
;               Branch if flag is zero.

		$CODE   COMPO+7,'?branch',QBRAN
        	pop     eax                       ;get ret addr
        	or      ebx,ebx                   ;?flag=0
        	jz      BRAN1                     ;yes, so branch
        	$POP_EBX
		add     eax, 4                    ;point PC to next cell
        	push    eax
        	ret
BRAN1:
        	$POP_EBX
        	push    [eax]                     ;IP:=(IP)
        	ret

;   branch      ( -- )
;               Branch to an inline address.

		$CODE   COMPO+6,'branch',BRAN
        	pop     eax                       ;get ret addr
        	push    [eax]                     ;IP:=(IP)
        	ret

;   !           ( w a -- )
;               Pop the data stack to memory.

		$CODE   1,'!',STORE
    	invoke  IsBadWritePtr, ebx , 4
		or      eax,eax
		jnz     GPF
		     
	    	mov     eax, [ebp]
		mov     [ebx], eax
		mov     ebx,4[ebp]
		add     ebp,8
		ret

;   @           ( a -- w )
;               Push memory location to the data stack.

		$CODE   1,'@',AT
	    	invoke  IsBadReadPtr, ebx, 4
            or      eax,eax
		    jnz     AT1
        	mov     ebx,[ebx]
        	ret
AT1:
        	jmp     GPF

;   C!          ( c b -- )
;               Pop the data stack to byte memory.

		$CODE   2,'C!',CSTOR
            invoke  IsBadWritePtr, ebx, 1
            or      eax,eax
            jnz     GPF
			
			mov     eax, [ebp]
        	mov     [ebx],al
        	mov     ebx, 4[ebp]
        	add     ebp,8
        	ret

;   C@          ( b -- c )
;               Push byte memory location to the data stack.

		$CODE   2,'C@',CAT
            invoke  IsBadReadPtr, ebx, 1
            or      eax,eax
            jnz     GPF

            xor     eax,eax
        	mov     al,[ebx]
            mov     ebx,eax
        	ret

;   RP@         ( -- a )
;               Push the current RP to the data stack.

		$CODE   3,'RP@',RPAT
        	pop     eax
		$PUSH_EBX
        	mov     ebx,esp
        	JMP     eax

;   RP!         ( a -- )
;               Set the return stack pointer.

		$CODE   COMPO+3,'RP!',RPSTO
        	POP     eax
        	MOV     esp,ebx
        	$POP_EBX
        	JMP     eax

;   R>          ( -- w )
;               Pop the return stack to the data stack.

		$CODE   2,'R>',RFROM
	    	$PUSH_EBX
		pop     eax
		pop     ebx
		jmp     eax

;   R@          ( -- w )
;               Copy top of return stack to the data stack.

		$CODE   2,'R@',RAT
	    	$PUSH_EBX
		mov     ebx, 4[esp]
		ret

;   >R          ( w -- )
;               Push the data stack to the return stack.

		$CODE   COMPO+2,'>R',TOR
        	pop     eax
        	push    ebx
		$POP_EBX
		jmp     eax

;   SP@         ( -- a )
;               Push the current data stack pointer.

		$CODE   3,'SP@',SPAT
	    	$PUSH_EBX
        	mov     ebx,ebp
        	ret

;   SP!         ( a -- )
;               Set the data stack pointer.

		$CODE   3,'SP!',SPSTO
        	mov     ebp,ebx
        	$POP_EBX
        	ret                               ; data stack reset , lodsd is not needed

;   DROP        ( w -- )
;               Discard top stack item.

		$CODE   4,'DROP',DROP
        	$POP_EBX
        	ret

;   DUP         ( w -- w w )
;               Duplicate the top stack item.

		$CODE   3,'DUP',DUPP
	    	$PUSH_EBX
        	ret

;   SWAP        ( w1 w2 -- w2 w1 )
;               Exchange top two stack items.

		$CODE   4,'SWAP',SWAP
	    	mov     eax, [ebp]
		mov     [ebp], ebx
		mov     ebx, eax
		ret

;   OVER        ( w1 w2 -- w1 w2 w1 )
;               Copy second stack item to top.

		$CODE   4,'OVER',OVER
	    	$PUSH_EBX
		mov     ebx, 4[ebp]
		ret

;   0<          ( n -- t )
;               Return true if n is negative.

		$CODE   2,'0<',ZLESS
        	mov     eax, ebx
		cdq                               ;sign extend
		mov     ebx, edx
        	ret

;   AND         ( w w -- w )
;               Bitwise AND.

		$CODE   3,'AND',ANDD
        	and     ebx,[ebp]
		lea     ebp,[ebp+4]
        	ret

;   OR          ( w w -- w )
;               Bitwise inclusive OR.

		$CODE   2,'OR',ORR
        	or      ebx,[ebp]
		lea     ebp,[ebp+4]
        	ret

;   XOR         ( w w -- w )
;               Bitwise exclusive OR.

		$CODE   3,'XOR',XORR
        	xor     ebx,[ebp]
        	add     ebp,4
        	ret

;   UM+         ( w w -- w cy )
;               Add two numbers, return the sum and carry flag.

		$CODE   3,'UM+',UPLUS
        	XOR     eax,eax                   ;CX=0 initial carry flag
        	ADD     ebx,[ebp]
        	RCL     eax,1                     ;get carry
        	MOV     [ebp],ebx                 ;push sum
        	MOV     ebx,eax
        	ret


;   CALLWIN  ( ... n addr -- res )  \ call windows api by address

        $CODE   7,"CALLWIN", CALLWIN
        mov     eax, ebx
		$POP_EBX
		mov     ecx, ebx            ; the address
        jmp     DOWINAPI1



;   doWINAPI    ( ... -- return ) run time routine for WINAPI:
        $CODE       8,"doWINAPI",DOWINAPI     
		$PUSH_EBX                   ; reserved for return value
        pop     esi                 ; get parameter field
		mov     eax, [esi]          ; winapi address
		mov     ecx, [esi+4]        ; number of parameter
DOWINAPI1:
		or      ecx,ecx        
        jz      DOWINAPI2           ; no more parameter
        mov     edx, [ebp]          ; move from data stack to return stack
        lea     ebp, [ebp+4]
		push    edx                 
        dec     ecx
		jmp     DOWINAPI1
DOWINAPI2:
        or      eax, eax
		jz      DOWINAPI3
		call    eax                 ; call the function
		mov     ebx, eax            ; put return value at tos
        ret
DOWINAPI3:
		invoke MessageBox,hwnd,0,0,MB_OK

	    ret


;   doCALLBACK   ( -- ) Runtime routine for windows call back function
;   warning : ebp is modified by windows, call back function cannot access forth datastack 
        $CODE       10,"doCALLBACK",DOCALLBACK

        pop     esi                 ; get parameter field

        push    ebp                 ; save ebp

        lea     eax, SPZERO
        lea     ebp, CB_DATASTACK   ; data stack for callback
		mov     [eax], ebp          ; adjust SPZERO

        mov     eax, [esi]          ; forth word cfa
        mov     ecx, [esi+4]        ; number of parameter


		mov     esi, esp
		add     esi,4               ; use esi to fetch parameters
        




DOCALLBACK1:                        ; move from return stack to callback datastack
        or      ecx,ecx
        jz      DOCALLBACK2
        $PUSH_EBX
        lea     esi, [esi+4]
        mov     ebx, [esi]
        dec     ecx

        jmp     DOCALLBACK1
DOCALLBACK2:
        call    eax                 ; call the forth word

        lea     eax, SPZERO          ; restore spzero
        lea     ebp, DATASTACK
		mov     [eax], ebp

        mov     eax,ebx             ; put return value in eax

		pop     ebp                 ; restore ebp
        ret


   $CODE        11,"FreeLibrary",FREELIBRARY  ; ( handle -- )
        invoke  FreeLibrary, ebx
		$POP_EBX
		ret

   $CODE        11,"LoadLibrary", LOADLIBRARY  ;( -name- )
	    call    BLANK
		call    WORDD
		call    COUNT
		call    DROP
		invoke  LoadLibrary, ebx
		mov     ebx,eax
        ret


    $CODE       14,"GetProcAddress",GETPROCADDRESS ; ( hmodule funcname -- pfunc)
		invoke  GetProcAddress, [ebp], ebx
		$POP_EBX
		mov     ebx, eax
		ret


;   doVAR       ( -- a )
;               Run time routine for VARIABLE and CREATE.

		$COLON  COMPO+5,'doVAR',DOVAR
        $PUSH_EBX                          
        pop     ebx
        ret

;   UP          ( -- a )
;               Pointer to the user area.

		$COLON  2,'UP',UP
		$PUSH_EBX
        	mov     ebx, offset UPP
		ret

;   doUSER      ( -- a )
;               Run time routine for user variables.

		$COLON  COMPO+6,'doUSER',DOUSE
		CALL	RFROM
		CALL	AT
		CALL	DOLIT
		DD	UZERO
		JMP	PLUS
		
;   SP0         ( -- a )
;               Pointer to bottom of the data stack.

		$USER   3,'SP0',SZERO

;   RP0         ( -- a )
;               Pointer to bottom of the return stack.

		$USER   3,'RP0',RZERO

;   '?KEY       ( -- a )
;               Execution vector of ?KEY.

		$USER   5,"'?KEY",TQKEY

;   'EMIT       ( -- a )
;               Execution vector of EMIT.

		$USER   5,"'EMIT",TEMIT

;   'EXPECT     ( -- a )
;               Execution vector of EXPECT.

		$USER   7,"'EXPECT",TEXPE

;   'TAP        ( -- a )
;               Execution vector of TAP.

		$USER   4,"'TAP",TTAP

;   'ECHO       ( -- a )
;               Execution vector of ECHO.

		$USER   5,"'ECHO",TECHO

;   'PROMPT     ( -- a )
;               Execution vector of PROMPT.

		$USER   7,"'PROMPT",TPROM

;   BASE        ( -- a )
;               Storage of the radix base for numeric I/O.

		$USER   4,'BASE',BASE

;   tmp         ( -- a )
;               A temporary storage location used in parse and find.

		$USER   COMPO+3,'tmp',TEMP

;   SPAN        ( -- a )
;               Hold character count received by EXPECT.

		$USER   4,'SPAN',SPAN

;   >IN         ( -- a )
;               Hold the character pointer while parsing input stream.

		$USER   3,'>IN',INN

;   #TIB        ( -- a )
;               Hold the current count and address of the terminal input buffer.

		$USER   4,'#TIB',NTIB
		_USER = _USER+CELLL

;   CSP         ( -- a )
;               Hold the stack pointer for error checking.

		$USER   3,'CSP',CSP

;   'EVAL       ( -- a )
;               Execution vector of EVAL.

		$USER   5,"'EVAL",TEVAL

;   'NUMBER     ( -- a )
;               Execution vector of NUMBER?.

		$USER   7,"'NUMBER",TNUMB

;   HLD         ( -- a )
;               Hold a pointer in building a numeric output string.

		$USER   3,'HLD',HLD

;   HANDLER     ( -- a )
;               Hold the return stack pointer for error handling.

		$USER   7,'HANDLER',HANDL

;   CONTEXT     ( -- a )
;               A area to specify vocabulary search order.

		$USER   7,'CONTEXT',CNTXT
		_USER = _USER+VOCSS*CELLL       ;vocabulary stack

;   CURRENT     ( -- a )
;               Point to the vocabulary to be extended.

		$USER   7,'CURRENT',CRRNT
		_USER = _USER+CELLL             ;vocabulary link pointer

;   CP          ( -- a )
;               Point to the top of the code dictionary.

		$USER   2,'CP',CP

;   NP          ( -- a )
;               Point to the bottom of the name dictionary.

		$USER   2,'NP',NP

;   LAST        ( -- a )
;               Point to the last name in the name dictionary.

		$USER   4,'LAST',LAST
		$USER   3,'CAP',CAP
   
        $USER   7, '(hinst)', WHINST
		$USER   6, '(hwnd)'  ,WHWND
		$USER   9, '(console)'  ,WHWNDCONSOLE
		$USER   9, '(dictend)', WDICTEND
		$USER   10,'(floadbuf)', WFLOADBUF
		;$USER   11,'(floadused)', WFLOADUSED
		;$USER   10,'(floadlen)', WFLOADLEN
		;$USER   12,'(floaddepth)', WFLOADDEPTH


;; Common functions

;   doVOC       ( -- )
;               Run time action of VOCABULARY's.

		$COLON  COMPO+5,'doVOC',DOVOC
		CALL	RFROM
		CALL	CNTXT
		JMP	STORE

;   FORTH       ( -- )
;               Make FORTH the context vocabulary.

		$COLON  5,'FORTH',FORTH
		CALL	DOVOC
		DD      LASTN                   ;vocabulary head pointer
		DD      0                       ;vocabulary link pointer
		RET
		
;   ?DUP        ( w -- w w | 0 )
;               Dup tos if its is not zero.

		$CODE   4,'?DUP',QDUP
        	OR      ebx,ebx
        	JNZ     QDUP1
        	ret
QDUP1:
        	$PUSH_EBX
        	ret

;   ROT         ( w1 w2 w3 -- w2 w3 w1 )
;               Rot 3rd item to top.

		$CODE   3,'ROT',ROT
	    	mov     ecx,ebx
		mov     ebx, 4[ebp]
		mov     eax, [ebp]
		mov     4[ebp],eax
		mov     [ebp],ecx
        	ret

;   2DROP       ( w w -- )
;               Discard two items on stack.

		$CODE   5,'2DROP',DDROP
	    	mov     ebx,4[ebp]
            lea     ebp,[ebp+8]
        	ret

;   2DUP        ( w1 w2 -- w1 w2 w1 w2 )
;               Duplicate top two items.

		$CODE   4,'2DUP',DDUP
        	sub     ebp,8
		mov     4[ebp],ebx
		mov     eax,8[ebp]
		mov     [ebp],eax
		ret

;   +           ( w w -- sum )
;               Add top two items.

		$CODE   1,'+',PLUS
        	add     ebx,[ebp]
		lea     ebp, [ebp+4]
        	ret

;   D+          ( d d -- d )
;               Double addition, as an example using UM+.
;
		$CODE   2,'D+',DPLUS
		POP     EAX
		POP     EDX
		POP     ECX
		ADD     EAX,ECX
		ADC     EBX,EDX
		PUSH    EAX
		RET

;   NOT         ( w -- w )
;               One's complement of tos.

		$CODE   3,'NOT',INVER
        	NOT     ebx
        	ret

;   NEGATE      ( n -- -n )
;               Two's complement of tos.

		$CODE   6,'NEGATE',NEGAT
        	NEG     ebx
        	ret

;   DNEGATE     ( d -- -d )
;               Two's complement of top double.

		$CODE   7,'DNEGATE',DNEGA
		POP     EAX
		NEG     EBX
		NEG     EAX
		SBB     EBX,0
		PUSH    EAX
		RET

;   -           ( n1 n2 -- n1-n2 )
;               Subtraction.

		$CODE   1,'-',SUBB
	    	neg     ebx
		add     ebx, [ebp]
		lea     ebp,[ebp+4]
		ret

;   ABS         ( n -- n )
;               Return the absolute value of n.

		$CODE   3,'ABS',ABSS
        	or      ebx,ebx 
        	jns     ABS1
        	neg     ebx
ABS1:   	ret

;   =           ( w w -- t )
;               Return true if top two are equal.

		$CODE   1,'=',EQUAL
        	cmp     [ebp], ebx
		mov     ebx,0
		jnz     EQU1
		dec     ebx
EQU1:
		lea     ebp,[ebp+4]
        	ret

;   U<          ( u u -- t )
;               Unsigned compare of top two items.

		$CODE   2,'U<',ULESS
        	cmp     [ebp],ebx
		sbb     ebx,ebx
		lea     ebp,[ebp+4]
        	ret

;   <           ( n1 n2 -- t )
;               Signed compare of top two items.

		$CODE   1,'<',LESS
        	cmp     [ebp],ebx
		lea     ebp, [ebp+4]
		mov     ebx,0
		jnl     LESS1
		dec     ebx
LESS1:
        	ret

;   MAX         ( n n -- n )
;               Return the greater of two top stack items.

		$CODE   3,'MAX',MAX
        call    DDUP
        call    LESS
        $QBRAN  MAX1
        call    SWAP
MAX1:  
        JMP    DROP

;   MIN         ( n n -- n )
;               Return the smaller of top two stack items.

		$CODE   3,'MIN',MIN
        call    DDUP
        call    SWAP
        call    LESS
        $QBRAN  MIN1
        call    SWAP
MIN1:  
        JMP    DROP

;   WITHIN      ( u ul uh -- t )
;               Return true if u is within the range of ul and uh.

		$CODE   6,'WITHIN',WITHI
        call    OVER
        call    SUBB
        call    TOR
        call    SUBB
        call    RFROM
        JMP    ULESS

;; Divide

;   UM/MOD      ( udl udh u -- ur uq )
;               Unsigned divide of a double by a single. Return mod and quotient.

		$CODE   6,'UM/MOD',UMMOD
        	mov     edx,[ebp]
		mov     eax,4[ebp]
		add     ebp,4
		div     ebx
		mov     [ebp],edx
		mov     ebx,eax
		ret

;   M/MOD       ( d n -- r q )
;               Signed floored divide of double by single. Return mod and quotient.

		$COLON  5,'M/MOD',MSMOD
        mov     edx,[ebp]
		mov     eax,4[ebp]
		lea     ebp,[ebp+4]
		idiv    ebx
		mov     [ebp],edx
		mov     ebx,eax
		ret

;   /MOD        ( n n -- r q )
;               Signed divide. Return mod and quotient.

		$CODE   4,'/MOD',SLMOD
        	mov     eax,[ebp]
		cdq
		idiv    ebx
		mov     ebx,eax
		mov     [ebp],edx
        	ret

;   MOD         ( n n -- r )
;               Signed divide. Return mod only.

		$COLON  3,'MOD',MODD
        	mov     eax,[ebp]
        	cdq
        	idiv    ebx
        	lea     ebp,[ebp+4]
        	mov     ebx,edx
        	ret

;   /           ( n n -- q )
;               Signed divide. Return quotient only.

		$COLON  1,'/',SLASH
        	mov     eax,[ebp]
        	cdq
        	idiv    ebx
        	lea     ebp,[ebp+4]
        	mov     ebx,eax      
        	ret

;; Multiply

;   UM*         ( u u -- ud )
;               Unsigned multiply. Return double product.

		$CODE   3,'UM*',UMSTA
        	mov     eax, [ebp]
        	mul     ebx
        	mov     [ebp],eax
        	mov     ebx,edx
        	ret

;   *           ( n n -- n )
;               Signed multiply. Return single product.

		$CODE   1,'*',STAR
        	mov     eax, [ebp]
        	mul     ebx
        	mov     ebx, eax
        	lea     ebp,[ebp+4]
        	ret

;   M*          ( n n -- d )
;               Signed multiply. Return double product.

		$CODE   2,'M*',MSTAR
        	mov     eax, [ebp]
        	imul    ebx
        	mov     [ebp],eax
        	mov     ebx,edx
        	ret

;   */MOD       ( n1 n2 n3 -- r q )
;               Multiply n1 and n2, then divide by n3. Return mod and quotient.

		$COLON  5,'*/MOD',SSMOD
        	mov     ecx, [ebp]
        	mov     eax, 4[ebp]
        	imul    ecx
        	lea     ebp,[ebp+4]
        	idiv    ebx
        	mov     [ebp],edx
        	mov     ebx,eax
        	ret

;   */          ( n1 n2 n3 -- q )
;               Multiply n1 by n2, then divide by n3. Return quotient only.

		$COLON  2,'*/',STASL
        	mov     ecx, [ebp]
		mov     eax, 4[ebp]
		imul    ecx
		lea     ebp,[ebp+8]
		idiv    ebx
		mov     ebx,eax
        	ret

;   U/          ( n1 n2 n3 -- q )
;               Multiply n1 by n2, then divide by n3. Return quotient only.

		$COLON  2,'U/',USLASH
        	mov     eax,[ebp]
        	cdq
        	div     ebx
        	lea     ebp,[ebp+4]
        	mov     ebx,eax      
        	ret

;; Miscellaneous

;   1+       ( n -- n+1 )
;               Add 1 to TOS.

		$CODE   2,'1+',ONEP
		inc	ebx
        	ret

;   1-       ( n -- n-1 )
;               Subtract 1 from TOS.

		$CODE   2,'1-',ONEM
	    	dec     ebx
        	ret

;   2+       ( n -- n+2 )
;               Add 2 to TOS.

		$CODE   2,'2+',TWOP
		add	ebx,2
        	ret

;   2-       ( n -- n-2 )
;               Subtract 2 from TOS.

		$CODE   2,'2-',TWOM
	    	lea     ebx,[ebx-2]
        	ret


;   shR | 2/    ( n -- n )  shift T to right by 1 bit, Carry and sign are preserved.
        $CODE   2,'2/', TWOSLASH
            SAR     ebx,1
            ret

;   shL | 2* ( n -- n )  shift T to left by 1 bit, Carry and sign are preserved.
        $CODE   2,'2*',TWO_STAR
            add     ebx,ebx
            ret


    $CODE	6,'LSHIFT', LSHIFT		; ( u1 n -- u2 )
            mov     ecx , ebx
            $POP_EBX
            shl     ebx , cl
            ret

    $CODE	6,'RSHIFT', RSHIFT		; ( u1 n -- u2 )
            mov     ecx , ebx
            $POP_EBX
            shr     ebx , cl
            ret
 
;   CELL+       ( a -- a )
;               Add cell size in byte to address.

		$CODE   5,'CELL+',CELLP
		add	ebx,4
        	ret

;   CELL-       ( a -- a )
;               Subtract cell size in byte from address.

		$CODE   5,'CELL-',CELLM
	    	lea     ebx,[ebx-4]
        	ret

;   CELLS       ( n -- n )
;               Multiply tos by cell size in bytes.

		$CODE   5,'CELLS',CELLS
        	shl     ebx,2
        	ret

;   ALIGNED     ( b -- a )
;               Align address to the cell boundary.

		$CODE   7,'ALIGNED',ALGND
        	add     ebx,3
        	and     ebx,0FFFFFFFCH
        	ret

;   0          ( -- 0 )
;               Return 0

		$COLON  1,'0',ZERO
		$PUSH_EBX
		XOR	EBX,EBX
        	ret

;   BL          ( -- 32 )
;               Return 32, the blank character.

		$COLON  2,'BL',BLANK
		$PUSH_EBX
        	MOV	EBX,20h
        	ret

;   >CHAR       ( c -- c )
;               Filter non-printing characters.

		$COLON  5,'>CHAR',T_CHAR
		CALL    DOLIT
		DD	07FH
		CALL    ANDD
		CALL    DUPP    ;mask msb
		CALL    BLANK
		CALL    DOLIT
		DD	127
		CALL    WITHI   ;check for printable
		CALL    INVER
		$QBRAN	TCHA1
		CALL    DROP
		CALL    DOLIT
		DD	'_'          ;replace non-printables
TCHA1:          RET

;   DEPTH       ( -- n )
;               Return the depth of the data stack.

		$COLON  5,'DEPTH',DEPTH
		CALL    SPAT
		CALL    SZERO
		CALL    AT
		CALL    SWAP
		CALL    SUBB
		CALL    DOLIT
		DD	CELLL
		JMP    SLASH

;   PICK        ( ... +n -- ... w )
;               Copy the nth stack item to tos.

		$CODE   4,'PICK',PICK
		shl	ebx,2
		mov	edi,ebx
		mov	ebx,[ebp+edi]
        ret

;; Memory access

;   +!          ( n a -- )
;               Add n to the contents at address a.

		$CODE   2,'+!',PSTOR
        mov     eax,[ebp]
		add     [ebx],eax
		mov     ebx,4[ebp]
		add     ebp,8
        ret

;   2!          ( d a -- )
;               Store the double integer to address a.

		$CODE   2,'2!',DSTOR
        mov     eax,[ebp]
		mov     ecx,4[ebp]
		mov     [ebx],eax
		mov     4[ebx],ecx
		mov     ebx,8[ebp]
        lea     ebp,[ebp+12]
        ret

;   2@          ( a -- d )
;               Fetch double integer from address a.

		$CODE   2,'2@',DAT
        lea     ebp,[ebp-4]
		mov     eax,4[ebx]
		mov     [ebp],eax
		mov     ebx,[ebx]
        ret

;   COUNT       ( b -- b +n )
;               Return count byte of a string and add 1 to byte address.

		$CODE   5,'COUNT',COUNT
		XOR     EAX,EAX
		MOV     AL,0[EBX]
		INC     EBX
		$PUSH_EBX
		MOV    	EBX,EAX
		RET

;   ZCOUNT     ( b -- b n ) return count byte of a null terminate string
       $CODE    6,'ZCOUNT',ZCOUNT
	    mov     edi, ebx
		xor     al,al
        
		repne   scasb

		$PUSH_EBX
		sub     edi, ebx
		dec     edi
		mov     ebx, edi
		ret


;   HERE        ( -- a )
;               Return the top of the code dictionary.

		$COLON  4,'HERE',HERE
        call    CP
        mov     ebx,[ebx]
        ret

;   PAD         ( -- a )
;               Return the address of a temporary buffer.

		$COLON  3,'PAD',PAD
		CALL    HERE
		CALL    DOLIT
		DD	80
		JMP    PLUS

;   TIB         ( -- a )
;               Return the address of the terminal input buffer.

		$COLON  3,'TIB',TIB
		CALL    NTIB
		CALL    CELLP
		JMP    AT

;   @EXECUTE    ( a -- )
;               Execute vector stored in address a.

		$CODE   8,'@EXECUTE',ATEXE
        invoke  IsBadCodePtr, [ebx]
        or      eax,eax
		jnz     GPF

        mov     eax,ebx
		$POP_EBX
        jmp     dword ptr [eax]                     ; as not using 'call ', then threaded into one routine

;   CMOVE       ( b1 b2 u -- )
;               Copy u bytes from b1 to b2.

		$CODE   5,'CMOVE',CMOVEE

; check if b1 is a valid read pointer
		$PUSH_EBX
		mov     ebx, [ebp+8]
        invoke  IsBadReadPtr, ebx , [ebp]
        or      eax,eax
		jnz     GPF

; check if b2 is a valid write pointer

		mov     ebx, [ebp+4]
        invoke  IsBadWritePtr, ebx , [ebp]
        or      eax,eax
		jnz     GPF

		$POP_EBX
	

        OR    	ebx,ebx
		jz 	CMOVE_2
		mov     edx,[ebp]
		mov     ecx,4[ebp]
CMOVE_1:
		mov     al,[ecx]
		mov     [edx],al
		inc     ecx
		inc     edx
		dec     ebx
		jnz     CMOVE_1
CMOVE_2:
		mov     ebx,8[ebp]
        	lea     ebp,[ebp+12]
        	ret

;   FILL        ( b u c -- )
;               Fill u bytes of character c to area beginning at b.

		$CODE   4,'FILL',FILL
; check if b is a valid write pointer
		$PUSH_EBX
		mov     ebx, [ebp+8]
        invoke  IsBadWritePtr, ebx , [ebp+4]
        or      eax,eax
		jnz     GPF

		$POP_EBX

	    mov     ecx, [ebp]
		OR      ecx,ecx
		jz      FILL2
		mov     edx,4[ebp]
FILL1:
		mov     [edx],bl
		inc     edx
		dec     ecx
		jnz     FILL1
FILL2:
		mov     ebx,8[ebp]
        	lea     ebp,[ebp+12]
        	ret


;   PACK$       ( b u a -- a )
;               Build a counted string with u characters from b. Null fill.

		$COLON  5,'PACK$',PACKS
		CALL	DDUP
		CALL	CSTOR
		CALL	DUPP
		CALL	TOR
		CALL	ONEP
		CALL	SWAP
		CALL	CMOVEE
		CALL	RFROM

;  add zero terminator
        CALL    DUPP
		CALL    DUPP
		CALL    CAT
		CALL    ONEP
		CALL    PLUS
		CALL    ZERO
		CALL    SWAP
		CALL    CSTOR

		RET
		

;; Numeric output, single precision

;   DIGIT       ( u -- c )
;               Convert digit u to a character.

		$COLON  5,'DIGIT',DIGIT
        	add     ebx,'0'                   ; assume 'A~.. '
        	cmp     ebx,'9'
        	jg      ABC_                      ; greater than 9
        	ret
ABC_:   	add     ebx,7
        	ret

;   EXTRACT     ( n base -- n c )
;               Extract the least significant digit from n.

		$COLON  7,'EXTRACT',EXTRC
		CALL    ZERO
		CALL    SWAP
		CALL    UMMOD
		CALL    SWAP
		JMP    DIGIT

;   <#          ( -- )
;               Initiate the numeric output process.

		$COLON  2,'<#',BDIGS
		CALL    PAD
		CALL    HLD
		JMP    STORE

;   HOLD        ( c -- )
;               Insert a character into the numeric output string.

		$COLON  4,'HOLD',HOLD
		CALL    HLD
		CALL    AT
		CALL    ONEM
		CALL    DUPP
		CALL    HLD
		CALL    STORE
		JMP     CSTOR

;   #           ( u -- u )
;               Extract one digit from u and append the digit to output string.

		$COLON  1,'#',DIG
		CALL    BASE
		CALL    AT
		CALL    EXTRC
		JMP     HOLD

;   #S          ( u -- 0 )
;               Convert u until all digits are added to the output string.

		$COLON  2,'#S',DIGS
DIGS1:          CALL    DIG
		CALL    DUPP
		$QBRAN	DIGS2
		$BRAN	DIGS1
DIGS2:          RET

;   SIGN        ( n -- )
;               Add a minus sign to the numeric output string.

		$COLON  4,'SIGN',SIGN
		CALL    ZLESS
		$QBRAN	SIGN1
		CALL    DOLIT
		DD	    '-'
		CALL    HOLD
SIGN1:          RET

;   #>          ( w -- b u )
;               Prepare the output string to be TYPE'd.

		$COLON  2,'#>',EDIGS
		CALL    DROP
		CALL    HLD
		CALL    AT
		CALL    PAD
		CALL    OVER
		JMP     SUBB

;   str         ( n -- b u )
;               Convert a signed integer to a numeric string.

		$COLON  3,'str',STRR
		CALL    DUPP
		CALL    TOR
		CALL    ABSS
		CALL    BDIGS
		CALL    DIGS
		CALL    RFROM
		CALL    SIGN
		JMP     EDIGS

;   HEX         ( -- )
;               Use radix 16 as base for numeric conversions.

		$COLON  3,'HEX',HEX
		CALL    DOLIT
		DD	16
		CALL    BASE
		JMP     STORE

;   DECIMAL     ( -- )
;               Use radix 10 as base for numeric conversions.

		$COLON  7,'DECIMAL',DECIM
		CALL    DOLIT
		DD	10
		CALL    BASE
		JMP     STORE

;; Numeric input, single precision

;   DIGIT?      ( c base -- u t )
;               Convert a character to its numeric value. A flag indicates success.

		$COLON  6,'DIGIT?',DIGTQ
		CALL    TOR
		CALL    DOLIT
		DD	'0'
		CALL    SUBB
		CALL    DOLIT
		DD	9
		CALL    OVER
		CALL    LESS
		$QBRAN	DGTQ1
		CALL    DOLIT
		DD	7
		CALL    SUBB
		CALL    DUPP
		CALL    DOLIT
		DD	10
		CALL    LESS
		CALL    ORR
DGTQ1:          CALL    DUPP
		CALL    RFROM
		JMP     ULESS

;   NUMBER?     ( a -- n T | a F )
;               Convert a number string to integer. Push a flag on tos.

		$COLON  7,'NUMBER?',NUMBQ
		CALL    BASE
		CALL    AT
		CALL    TOR
		CALL    ZERO
		CALL    OVER
		CALL    COUNT
		CALL    OVER
		CALL    CAT
		CALL    DOLIT
		DD	    '$'
		CALL    EQUAL
		$QBRAN	NUMQ1
		CALL    HEX
		CALL    SWAP
		CALL    ONEP
		CALL    SWAP
		CALL    ONEM
NUMQ1: 
        CALL    OVER
		CALL    CAT
		CALL    DOLIT
		DD	    '-'
		CALL    EQUAL
		CALL    TOR
		CALL    SWAP
		CALL    RAT
		CALL    SUBB
		CALL    SWAP
		CALL    RAT
		CALL    PLUS
		CALL    QDUP
		$QBRAN	NUMQ6
		CALL    ONEM
		CALL    TOR
NUMQ2:
        CALL    DUPP
		CALL    TOR
		CALL    CAT
		CALL    BASE
		CALL    AT
		CALL    DIGTQ
		$QBRAN	NUMQ4
		CALL    SWAP
		CALL    BASE
		CALL    AT
		CALL    STAR
		CALL    PLUS
		CALL    RFROM
		CALL    ONEP
		CALL    DONXT
        DD      NUMQ2
		CALL    RAT
		CALL    SWAP
		CALL    DROP
		$QBRAN  NUMQ3
		CALL    NEGAT
NUMQ3:  
        CALL    SWAP
		$BRAN	NUMQ5
NUMQ4:
        CALL    RFROM
		CALL    RFROM
		CALL    DDROP
		CALL    DDROP
		CALL    ZERO
NUMQ5: 
        CALL    DUPP
NUMQ6:   
        CALL    RFROM
		CALL    DDROP
        CALL    RFROM
		CALL    BASE
		JMP     STORE

;; Basic I/O

;   ?KEY        ( -- c T | F )
;               Return input character and true, or a false if no input.

		$COLON  4,'?KEY',QKEY
        $PUSH_EBX
        call    HostKeyq
        .if     al > 0
          mov  ebx, eax
          $PUSH_EBX
          xor  ebx,ebx
          dec  ebx             ; push true flag
        .else
		   xor  ebx,ebx
        .endif
        ret

;   PAUSE         ( -- )
;               Wait for and return an input character.
        $COLON    5,'PAUSE',PAUSE_
        call    HostProcessMessage
		.if     eax==0
		   call BYE
		.endif
        ret




  
; BLOAD  ( buf len --  )   \ compile a buffer
  $CODE 5,'BLOAD',BLOAD
 
        inc floaddepth

		lea	eax, NTIB_
		push   [eax]        ; save #tib
		lea	eax, [eax+4]    
		push   [eax]        ; save tib
		lea	eax, INN_
		push   [eax]        ; save >in


		lea  esi, NTIB_
		mov  [esi], ebx
        $POP_EBX            ; len

		lea  esi,[esi+4]    ; tib
		mov  [esi], ebx     ; set tib to begin of buffer
        $POP_EBX		
  
		lea	esi, INN_
		xor	eax,eax
		mov	[esi], eax		; reset >in to zero

		call DOLIT
		dd   EVAL
        call CATCH          ; start interpret

        lea  esi, NTIB_
		mov  eax,[esi]
		sub [floadused], eax ; substract used byte
        jmp  BFLOAD_DONE


BFLOAD_DONE:
		dec	floaddepth
				
		or	ebx,ebx
		jnz	BFLOAD_ERROR
        $POP_EBX            ; drop error code = 0

        lea	eax, INN_
		pop	[eax]			; restore >in
		lea	eax, NTIB_
		pop	[eax+4]			; restore tib
		pop	ecx
		mov	[eax], ecx		; restore #tib


		ret


BFLOAD_ERROR:	            
        CALL    SPACE
        CALL    COUNT 
	    CALL    TYPEE           ; type error message
        D$      DOTQP,' ?  Error, Line:'

		$PUSH_EBX              
		xor     ebx,ebx
		inc     ebx             ; first line

; count lines        
		mov     edi, NTIB_
		lea     edi, [edi+4]
		mov     edi, [edi]      ; address of file

		lea     eax, INN_
		mov     ecx, [eax]      ; offset from top of file

        mov     eax, 0AH
         
count_line_again:
		repne   scasb
		jcxz    count_line_finish
        inc     ebx
		jmp    count_line_again
count_line_finish:        
        
		; type line number
		CALL    BASE
		CALL    AT
		CALL    TOR
		CALL    DECIM
        CALL    DOT             ; type error line #
		CALL    RFROM
		CALL    BASE
		CALL    STORE
		            
		CALL    CR
		CALL    LBRAC

		pop     eax             ; >in tib #tib is not used
		pop     eax
		pop     eax

		xor	eax,eax
		lea	esi, NTIB_
		mov	[esi], eax		    ; reset #tib
		lea	esi, [esi+4]
		mov	[esi], offset TIBB	; restore tib
		lea	esi, INN_
		mov	[esi], eax	        ; reset >in

		ret
		


; DOFLOAD  ( filenamestr -- )   ; load a nullterminated filename 
  $CODE 7, 'doFLOAD', DOFLOAD
        CALL    ZCOUNT

		$PUSH_EBX
		mov	ebx, floaddepth
		call	SPACS			; indent
		D$      DOTQP,'Loading '
		call	DDUP
		call	TYPEE
		$POP_EBX                ; drop file name count

; open the file and get filesize
		call	HostCreateFile
		$POP_EBX                 ; drop file name
		cmp	    eax, 0
		jle	    BFLOAD_ERROR_OPEN
        
		mov     filehandle, eax

		invoke	GetFileSize,filehandle,NULL 
		mov filesize, eax


        ; set count and new tib 
		mov  eax, floadused
		add  eax, filesize

		cmp  eax, floadlen         ; exceed buffer size
		jg BFLOAD_ERROR_MEMORY
		mov  [floadused], eax

		add eax, [floadbuf]
		sub eax, filesize          ; new position
		$PUSH_EBX
		mov ebx, eax
		$PUSH_EBX
		mov ebx, filesize

		; read	entire file from TIB
		invoke	ReadFile,filehandle,eax,filesize,ADDR readbyte,NULL
		invoke  HostCloseFile, filehandle
        
		call  BLOAD
		ret

BFLOAD_ERROR_OPEN:
		D$      DOTQP,' failed.'
		$POP_EBX
		ret
BFLOAD_ERROR_MEMORY:
        CALL  CR
		D$      DOTQP,'fload buffer overflow.'
		$POP_EBX
		ret


;   FLOAD   ( -filename- )  \ compile a file
$COLON  5,'FLOAD',	FLOAD
		CALL    DOLIT
		DD      20H
		call	WORDD
		call    COUNT
		call    DROP
		call	DOFLOAD
		ret


;   KEY         ( -- c )
;               Wait for and return an input character.

		$COLON  3,'KEY',KEY

KEY1:           
        CALL    PAUSE_
        CALL    QKEY
        $QBRAN	KEY1
		MOV     lastkey, 0H    ; clear lastkey
        RET

;   EMIT        ( c -- )
;               Send a character to the output device.

		$COLON  4,'EMIT',EMIT
  		invoke HostEmit
  		xor eax,eax
  		mov lastkey,eax
  		RET
;        	call    HostEmit
;        	$POP_EBX
;        	ret

;   NUF?        ( -- t )
;               Return false if no input, else pause and if CR return true.

		$COLON  4,'NUF?',NUFQ
		CALL    QKEY
		CALL    DUPP
		$QBRAN	NUFQ1
		CALL    DDROP
		CALL    KEY
		CALL    DOLIT
		DD	CRR
		CALL    EQUAL
NUFQ1:          RET

;   PACE        ( -- )
;               Send a pace character for the file downloading process.

		$COLON  4,'PACE',PACE
		CALL    DOLIT
		DD	11
		JMP    EMIT

;   SPACE       ( -- )
;               Send the blank character to the output device.

		$COLON  5,'SPACE',SPACE
		CALL    BLANK
		JMP    EMIT

;   SPACES      ( +n -- )
;               Send n spaces to the output device.

		$COLON  6,'SPACES',SPACS
		CALL    ZERO
		CALL    MAX
		CALL    TOR
		$BRAN	CHAR2
CHAR1:          CALL    SPACE
CHAR2:          CALL    DONXT
		DD	CHAR1
		RET

;   TYPE        ( b u -- )
;               Output u characters from b.

		$COLON  4,'TYPE',TYPEE

		CALL    TOR
		$BRAN	TYPE2
TYPE1:  
        CALL    DUPP
		CALL    CAT
		CALL    EMIT
		CALL    ONEP
TYPE2:  
        CALL    DONXT
		DD	TYPE1
		JMP    DROP


;   CR          ( -- )
;               Output a carriage return and a line feed.

		$COLON  2,'CR',CR
		CALL	DOLIT
		DD	    0DH
		CALL	EMIT
		;CALL	DOLIT
		;DD	    0AH
		;CALL    EMIT
		CALL    HostFlush
		RET

;   do$         ( -- a )
;               Return the address of a compiled string.

		$COLON  COMPO+3,'do$',DOSTR
		CALL    RFROM
		CALL    RAT
        CALL    RFROM
		CALL    COUNT
		CALL    PLUS
		CALL    ONEP                         ; skip NULL terminator
        CALL    TOR
		CALL    SWAP
		CALL    TOR
		RET

;   $"|		( -- a )
;               Run time routine compiled by $". Return address of a compiled string.

		$COLON  COMPO+3,'$"|',STRQP
		call    RFROM
        call    DUPP
        call    COUNT
        call    PLUS
		call    ONEP
        call    TOR
		jmp    COUNT

;		JMP    DOSTR
;		RET              ;force a call to do$

;   ."|		( -- )
;               Run time routine of ." . Output a compiled string.

		$COLON  COMPO+3,'."|',DOTQP
		CALL    DOSTR
		CALL    COUNT
		JMP    TYPEE

;   Z"|    
;               Run time routine of Z" . push null terminate compiled string on stack
        $COLON  COMPO+3,'Z"|', ZQP
		CALL    DOSTR
		JMP     ONEP


;   .R          ( n +n -- )
;               Display an integer in a field of n columns, right justified.

		$COLON  2,'.R',DOTR
		CALL    TOR
		CALL    STRR
		CALL    RFROM
		CALL    OVER
		CALL    SUBB
		CALL    SPACS
		JMP    TYPEE

;   U.R         ( u +n -- )
;               Display an unsigned integer in n column, right justified.

		$COLON  3,'U.R',UDOTR
		CALL    TOR
		CALL    BDIGS
		CALL    DIGS
		CALL    EDIGS
		CALL    RFROM
		CALL    OVER
		CALL    SUBB
		CALL    SPACS
		JMP    TYPEE

;   U.          ( u -- )
;               Display an unsigned integer in free format.

		$COLON  2,'U.',UDOT
		CALL    BDIGS
		CALL    DIGS
		CALL    EDIGS
		CALL    SPACE
		JMP    TYPEE

;   .           ( w -- )
;               Display an integer in free format, preceeded by a space.

		$COLON  1,'.',DOT
		CALL    BASE
		CALL    AT
		CALL    DOLIT
		DD	10
		CALL    XORR   ;?decimal
		$QBRAN	DOT1
		CALL    UDOT
		RET               ;no, display unsigned
DOT1:           CALL    STRR
		CALL    SPACE
		JMP    TYPEE
;		RET    ;yes, display signed

;   ?           ( a -- )
;               Display the contents in a memory cell.

		$COLON  1,'?',QUEST
		CALL    AT
		JMP    DOT

;; Parsing

;   parse       ( b u c -- b u delta ; <string> )
;               Scan string delimited by c. Return found string and its offset.

		$COLON  5,'doPARSE',PARS
		CALL    TEMP
		CALL    STORE
		CALL    OVER
		CALL    TOR
		CALL    DUPP
		$QBRAN	PARS8
		CALL    ONEM
		CALL    TEMP
		CALL    AT
		CALL    BLANK
		CALL    EQUAL
		$QBRAN	PARS3
		CALL    TOR
PARS1:          CALL    BLANK
		CALL    OVER
		CALL    CAT          ;skip leading blanks ONLY
		CALL    SUBB
		CALL    ZLESS
		CALL    INVER
		$QBRAN	PARS2
		CALL    ONEP
		CALL    DONXT
		DD	PARS1
		CALL    RFROM
		CALL    DROP
		CALL    ZERO
		CALL    DUPP
		RET
PARS2:          CALL    RFROM
PARS3:          CALL    OVER
		CALL    SWAP
		CALL    TOR
PARS4:          CALL    TEMP
		CALL    AT
		CALL    OVER
		CALL    CAT
		CALL    SUBB   ;scan for delimiter
		CALL    TEMP
		CALL    AT
		CALL    BLANK
		CALL    EQUAL
		$QBRAN	PARS5
		CALL    ZLESS
PARS5:          $QBRAN	PARS6
		CALL    ONEP
		CALL    DONXT
		DD	PARS4
		CALL    DUPP
		CALL    TOR
		$BRAN	PARS7
PARS6:          CALL    RFROM
		CALL    DROP
		CALL    DUPP
		CALL    ONEP
		CALL    TOR
PARS7:          CALL    OVER
		CALL    SUBB
		CALL    RFROM
		CALL    RFROM
		CALL    SUBB
		RET
PARS8:          CALL    OVER
		CALL    RFROM
		JMP    SUBB

;   PARSE       ( c -- b u ; <string> )
;               Scan input stream and return counted string delimited by c.

		$COLON  5,'PARSE',PARSE
		CALL    TOR
		CALL    TIB
		CALL    INN
		CALL    AT
		CALL    PLUS     ;current input buffer pointer
		CALL    NTIB
		CALL    AT
		CALL    INN
		CALL    AT
		CALL    SUBB     ;remaining count
		CALL    RFROM
		CALL    PARS
		CALL    INN
		JMP    PSTOR

;   .(          ( -- )
;               Output following string up to next ) .

		$COLON  IMEDD+2,'.(',DOTPR
		CALL    DOLIT
		DD	')'
		CALL    PARSE
		JMP    TYPEE

;   (           ( -- )
;               Ignore following string up to next ) . A comment.

		$COLON  IMEDD+1,'(',PAREN
		CALL    DOLIT
		DD	')'
		CALL    PARSE
		JMP    DDROP

;   \           ( -- )
;               Ignore following text till the end of line.

		$COLON  IMEDD+1,'\',BKSLA
        CALL    DOLIT
		DD      0DH
        call    WORDD
        jmp     DROP

;   CHAR        ( -- c )
;               Parse next word and return its first character.

		$COLON  4,'CHAR',CHAR_
		CALL    BLANK
		CALL    PARSE
		CALL    DROP
		JMP    CAT

;   TOKEN       ( -- a ; <string> )
;               Parse a word from input stream and copy it to name dictionary.

		$COLON  5,'TOKEN',TOKEN
		CALL    BLANK
		CALL    PARSE
		CALL    DOLIT
		DD	31
		CALL    MIN
		CALL    CP
		CALL    AT
		CALL    CELLP
		JMP    PACKS

;   WORD        ( c -- a ; <string> )
;               Parse a word from input stream and copy it to code dictionary.

		$COLON  4,'WORD',WORDD
		CALL    PARSE
		CALL    HERE
		CALL	CELLP
		JMP    PACKS



;; Dictionary search

;   NAME>       ( na -- ca )
;               Return a code address given a name address.

		$COLON  5,'NAME>',NAMET
		CALL    COUNT
		CALL	DOLIT
		DD	MASKK
		CALL	ANDD
		CALL    PLUS                   ;32 bit cells, 16 bit values.
		CALL    ONEP                   ;skip NULL terminator
		RET


;   find        ( a va -- ca na | a F )
;               Search a vocabulary for a string. Return ca and na if succeeded.

		$COLON  4,'find',FIND
        mov     ebx, [ebx]
		or      ebx, ebx
		jz      FIND_VOC_ZERO       
		push    ebx                     ; save va ptr
        mov     edx, 1                  ; always start from can sensitive search , edx=0 case insensitive search
		xor     ecx, ecx

FIND_RESTART:
		pop     ebx
		push    ebx

        mov     esi, [ebp]

		mov     cl,  [esi]              ; string count
		and     cl, 1FH                 ; length mask
		inc     cl                      ; compare count = count byte + string len 
		inc     esi
		         
		mov     edi, ebx                
		inc     edi
		cld
		
FIND_AGAIN:	
        xor     eax,eax

FIND_COMPARE:
        or      cl,cl
        jz      FIND_FOUND
		dec     cl
		mov     ah, BYTE PTR [edi]      ; load target
        inc     edi                     ; edi+1
		lodsb                           ; load pattern, esi+1

        or      edx,edx 
		jnz     FIND_CASEOK
        
		; convert pattern to uppercase
        cmp     al,'a'
		jb      FIND_PATTERN_OK
		cmp     al,'z'
        ja      FIND_PATTERN_OK
		sub     al, 20H

FIND_PATTERN_OK:
		; convert target to uppercase
        cmp     ah,'a'
		jb      FIND_CASEOK
		cmp     ah,'z'
        ja      FIND_CASEOK
		sub     ah, 20H

FIND_CASEOK:
		cmp     al, ah 
		je      FIND_COMPARE
        
FIND_AGAIN2:
		sub     ebx, 4
		mov     eax, [ebx]              ; link field

		or      eax, eax                ; link field is zero
		jz      FIND_NOTFOUND

		mov     ebx, eax                ; next cell

		mov     esi, [ebp]

		mov     cl,  [esi]
		and     cl , 1FH
		inc     cl
		inc     esi                     ; skip count byte

		mov     edi, ebx
		inc     edi                     ; skip count byte
		jmp     FIND_AGAIN

FIND_FOUND:
        or      ecx, ecx                ; make sure all byte consumed
        jnz     FIND_AGAIN2

        pop     ecx                     ; throw va
		xor     ecx, ecx
        mov     eax, ebx                ; na in ebx
		mov     cl, [ebx]               ; get count byte
		and     cl, 1FH
		add     eax, ecx                ; add count to na 
		inc     eax                     ; skip count byte
		inc     eax                     ; skip null terminater
        mov     [ebp], eax              ; ca


		RET

FIND_NOTFOUND:
        lea     esi, CAP_
		add     edx , [esi]             ; if CAP is on , edx+ cap will be zero
		or      edx, edx                ; edx = 0 ?
        jz      FIND_RESTART            ; restart with case insensitive search

        pop     ebx
        xor     ebx,ebx                 ; false flag
FIND_VOC_ZERO:
        RET



;   NAME?       ( a -- ca na | a F )
;               Search all context vocabularies for a string.

		$COLON  5,'NAME?',NAMEQ
		CALL    CNTXT
		CALL    DUPP
		CALL    DAT
		CALL    XORR     ;?context=also
		$QBRAN	NAMQ1
		CALL    CELLM                   ;no, start with context
NAMQ1:          CALL    TOR
NAMQ2:          CALL    RFROM
		CALL    CELLP
		CALL    DUPP
		CALL    TOR    ;next in search order
		CALL    AT
		CALL    QDUP
		$QBRAN	NAMQ3
		CALL    FIND
		CALL    QDUP               ;search vocabulary
		$QBRAN	NAMQ2
		CALL    RFROM
		CALL    DROP
		RET         ;found name
NAMQ3:          CALL    RFROM
		CALL    DROP              ;name not found
		JMP    ZERO
;		RET            ;false flag

;; Terminal response

;   ^H          ( bot eot cur -- bot eot cur )
;               Backup the cursor by one character.

		$COLON  2,'^H',BKSP
		CALL    TOR
		CALL    OVER
		CALL    RFROM
		CALL    SWAP
		CALL    OVER
		CALL    XORR
		$QBRAN	BACK1
		CALL    DOLIT
		DD	BKSPP
		CALL    TECHO
		CALL    ATEXE
		CALL    ONEM
		CALL    BLANK
		CALL    TECHO
		CALL    ATEXE
		CALL    DOLIT
		DD	BKSPP
		CALL    TECHO
		CALL    ATEXE
BACK1:          RET

;   TAP         ( bot eot cur c -- bot eot cur )
;               Accept and echo the key stroke and bump the cursor.

		$COLON  3,'TAP',TAP
		CALL    DUPP
		CALL    TECHO
		CALL    ATEXE
		CALL    OVER
		CALL    CSTOR
		JMP    ONEP

;   kTAP        ( bot eot cur c -- bot eot cur )
;               Process a key stroke, CR or backspace.

		$COLON  4,'kTAP',KTAP
		CALL    DUPP
		CALL    DOLIT
		DD	CRR
		CALL    XORR
		$QBRAN	KTAP2
		CALL    DOLIT
		DD	BKSPP
		CALL    XORR
		$QBRAN	KTAP1
		CALL    BLANK
		CALL    TAP
		RET
KTAP1:          CALL    BKSP
		RET
KTAP2:          CALL    DROP
		CALL    SWAP
		CALL    DROP
		JMP    DUPP

;   accept      ( b u -- b u )
;               Accept characters to input buffer. Return with actual count.

		$COLON  6,'accept',ACCEP
		CALL    OVER
		CALL    PLUS
		CALL    OVER
ACCP1:          CALL    DDUP
		CALL    XORR
		$QBRAN	ACCP4
		CALL    KEY
		CALL    DUPP
;       CALL    BLANK   
;		CALL    SUBB
;		CALL    DOLIT
;		DD	95
;		CALL    ULESS
		CALL    BLANK
		CALL    DOLIT
		DD	256         ; accept chinese
		CALL    WITHI
		$QBRAN	ACCP2
		CALL    TAP
		$BRAN	ACCP3
ACCP2:          CALL    TTAP
		CALL    ATEXE
ACCP3:          $BRAN	ACCP1
ACCP4:          CALL    DROP
		CALL    OVER
		JMP    SUBB

;   EXPECT      ( b u -- )
;               Accept input stream and store count in SPAN.

		$COLON  6,'EXPECT',EXPEC
		CALL    TEXPE
		CALL    ATEXE
		CALL    SPAN
		CALL    STORE
		CALL    DROP
		RET

;   QUERY       ( -- )
;               Accept input stream to terminal input buffer.

		$COLON  5,'QUERY',QUERY
		CALL    TIB
		CALL    DOLIT
		DD	80
		CALL    TEXPE
		CALL    ATEXE
		CALL    NTIB
		CALL    STORE
		CALL    DROP
		CALL    ZERO
		CALL    INN
		JMP    STORE

;; Error handling

;   CATCH       ( ca -- 0 | err# )
;               Execute word at ca and set up an error frame for it.

		$COLON  5,'CATCH',CATCH
		CALL    SPAT
		CALL    TOR
		CALL    HANDL
		CALL    AT
		CALL    TOR   ;save error frame
		CALL    RPAT
		CALL    HANDL
		CALL    STORE
		CALL    EXECU  ;execute
		CALL    RFROM
		CALL    HANDL
		CALL    STORE       ;restore error frame
		CALL    RFROM
		CALL    DROP
		JMP    ZERO
;		RET ;no error

;   THROW       ( err# -- err# )
;               Reset system to current local error frame an update error flag.

		$COLON  5,'THROW',THROW
		CALL    HANDL
		CALL    AT
		CALL    RPSTO          ;restore return stack
		CALL    RFROM
		CALL    HANDL
		CALL    STORE       ;restore handler frame
		CALL    RFROM
		CALL    SWAP
		CALL    TOR
		CALL    SPSTO       ;restore data stack
		CALL    DROP
		CALL    RFROM
		RET

;   NULL$       ( -- a )
;               Return address of a null string with zero count.

		$COLON  5,'NULL$',NULLS
		CALL    DOVAR                   ;emulate CREATE
		DB      99,111,121,111,116,101
		

;   ABORT       ( -- )
;               Reset data stack and jump to QUIT.

		$COLON  5,'ABORT',ABORT
		CALL    NULLS
		JMP    THROW

;   abort"	( f -- )
;               Run time routine of ABORT" . Abort with a message.

		$COLON  COMPO+6,'doABORT"',ABORQ
		$QBRAN	ABOR1             ;text flag
		CALL    DOSTR
		CALL    THROW             ;pass error string
ABOR1:          CALL    DOSTR
		JMP    DROP
;		RET         ;drop error

;; The text interpreter

;   $INTERPRET  ( a -- )
;               Interpret a word. If failed, try to convert it to an integer.

		$COLON  10,'$INTERPRET',INTER
		CALL    NAMEQ
		CALL    QDUP              ;?defined
		$QBRAN	INTE1
		CALL    AT
		CALL    DOLIT
		DD	COMPO
		CALL    ANDD   ;?compile only lexicon bits
		D$      ABORQ,' compile only'
		CALL    EXECU
		RET              ;execute defined word
INTE1:          CALL    TNUMB
		CALL    ATEXE             ;convert a number
		$QBRAN	INTE2
		RET
INTE2:          CALL    THROW                   ;error

;   [           ( -- )
;               Start the text interpreter.

		$COLON  IMEDD+1,'[',LBRAC
		CALL    DOLIT
		DD	INTER
		CALL    TEVAL 
		JMP    STORE

;   .OK         ( -- )
;               Display 'ok' only while interpreting.

		$COLON  3,'.OK',DOTOK
		CALL    DOLIT
		DD	INTER
		CALL    TEVAL
		CALL    AT
		CALL    EQUAL
		$QBRAN	DOTO1
		D$      DOTQP,' ok'
DOTO1:          JMP    CR

;   ?STACK      ( -- )
;               Abort if the data stack underflows.

		$COLON  6,'?STACK',QSTAC
		CALL    DEPTH
		CALL    ZLESS             ;check only for underflow
		D$      ABORQ,' underflow'
		RET

;   EVAL        ( -- )
;               Interpret the input stream.

		$COLON  4,'EVAL',EVAL
EVAL1: 
        CALL    TOKEN
		CALL    DUPP
		CALL    CAT          ;?input stream empty
		$QBRAN	EVAL2
		CALL    TEVAL
		CALL    ATEXE
		CALL    QSTAC       ;evaluate input, check stack
		$BRAN	EVAL1
EVAL2:          CALL    DROP
		CALL    TPROM
		JMP    ATEXE
;		RET   ;prompt

;; Shell

;   PRESET      ( -- )
;               Reset data stack pointer and the terminal input buffer.

		$COLON  6,'PRESET',PRESE
		CALL    SZERO
		CALL    AT
		CALL    SPSTO
		CALL    DOLIT
		DD	TIBB
		CALL    NTIB
		CALL    CELLP
		JMP    STORE

;   xio         ( a a a -- )
;               Reset the I/O vectors 'EXPECT, 'TAP, 'ECHO and 'PROMPT.

		$COLON  COMPO+3,'xio',XIO
		CALL    DOLIT
		DD	ACCEP
		CALL    TEXPE
		CALL    DSTOR
		CALL    TECHO
		JMP    DSTOR

;   FILE        ( -- )
;               Select I/O vectors for file download.

		$COLON  4,'FILE',FILE
		CALL    DOLIT
		DD	PACE
		CALL    DOLIT
		DD	DROP
		CALL    DOLIT
		DD	KTAP
		JMP    XIO

;   HAND        ( -- )
;               Select I/O vectors for terminal interface.

		$COLON  4,'HAND',HAND
		CALL    DOLIT
		DD	DOTOK
		CALL    DOLIT
		DD	EMIT
		CALL    DOLIT
		DD	KTAP
		JMP    XIO

;   I/O         ( -- a )
;               Array to store default I/O vectors.

		$COLON  3,'I/O',ISLO
		CALL    DOVAR                   ;emulate CREATE
		DD    	QRX
		DD    	TXSTO               ;default I/O vectors
						;for 32 bit system 3/16/92

;   CONSOLE     ( -- )
;               Initiate terminal interface.

		$COLON  7,'CONSOLE',CONSO
		CALL    ISLO
		CALL    DAT
		CALL    TQKEY
		CALL    DSTOR    ;restore default I/O device
		JMP    HAND
;		RET               ;keyboard input

;   QUIT        ( -- )
;               Reset return stack pointer and start text interpreter.

		$COLON  4,'QUIT',QUIT
			
		CALL    RZERO          ;RP0 refer to esp
		CALL    AT
		CALL    AT
		CALL    RPSTO          ;reset return stack pointer
QUIT1:          CALL    LBRAC                   ;start interpretation
QUIT2:          CALL    QUERY                   ;get input
		CALL    DOLIT
		DD	EVAL
		CALL    CATCH
		CALL    QDUP   ;evaluate input
		$QBRAN	QUIT2             ;continue till error
		CALL    TPROM
		CALL    AT
		CALL    SWAP           ;save input device
		CALL    CONSO
		CALL    NULLS
		CALL    OVER
		CALL    XORR   ;?display error message
		$QBRAN	QUIT3
		CALL    SPACE
		CALL    COUNT
		CALL    TYPEE       ;error message
		D$      DOTQP,' ? '             ;error prompt
		CALL    CR
QUIT3:          CALL    DOLIT
		DD	DOTOK
		CALL    XORR        ;?file input
		$QBRAN	QUIT4
		CALL    DOLIT
		DD	ERR
		CALL    EMIT          ;file error, tell host
QUIT4:          CALL    PRESE                   ;some cleanup
		$BRAN	QUIT1

;; The compiler

;   '           ( -- ca )
;               Search context vocabularies for the next word in input stream.

		$COLON  1,"'",TICK
		CALL    TOKEN
		CALL    NAMEQ             ;?defined
		$QBRAN	TICK1
		RET                    ;yes, push code address
TICK1:          JMP    THROW                   ;no, error


    $COLON      3+IMEDD+COMPO,"[']",BRACKET_TICK
	    call    TICK
		CALL    DOLIT
		DD      DOLIT
		call    CALLC
		call    COMMA
		ret


;   ALLOT       ( n -- )
;               Allocate n bytes to the code dictionary.

		$COLON  5,'ALLOT',ALLOT
		CALL    CP
		JMP    PSTOR
;		RET           ;adjust code pointer

;   ,           ( w -- )
;               Compile an integer into the code dictionary.

		$COLON  1,',',COMMA
		CALL    HERE
		CALL    DUPP
		CALL    CELLP         ;cell boundary
		CALL    CP
		CALL    STORE
		CALL    STORE
		RET     ;adjust code pointer, compile

;   C,           ( b -- )
;               Compile a byte into the code dictionary.

		$COLON  2,'C,',CCOMMA
		CALL    HERE
		CALL    DUPP
		CALL    ONEP 
		CALL    CP
		CALL    STORE
		JMP    CSTOR
;		RET     ;adjust code pointer, compile

;   [COMPILE]   ( -- ; <string> )
;               Compile the next immediate word into code dictionary.

		$COLON  IMEDD+9,'[COMPILE]',BCOMP
		CALL    TICK
		JMP    CALLC

;   COMPILE     ( -- )
;               Compile the next address in colon list to code dictionary.

		$COLON  COMPO+7,'COMPILE',COMPI
		CALL    RFROM
		CALL	ONEP
		CALL    DUPP
		CALL    AT
		CALL	SWAP
		CALL	CELLP
		CALL	DUPP
		CALL	TOR
		CALL	PLUS
		CALL    CALLC     ;compile address
		RET          ;adjust return address

;   LITERAL     ( n -- )
;               Compile tos to code dictionary as an integer literal.

		$COLON  IMEDD+7,'LITERAL',LITER
		CALL    COMPI
		CALL    DOLIT
		JMP	COMMA

;   $,"		( -- )
;               Compile a literal string up to next " .

		$COLON  3,'$,"',STRCQ
		CALL    DOLIT
		DD	'"'
		CALL    PARSE
		CALL    HERE
		CALL    PACKS
		CALL    COUNT
		CALL    PLUS
		CALL    ONEP    ; skip null terminator
		CALL    CP
		JMP    STORE
;		RET           ;adjust the code pointer

;   RECURSE     ( -- )
;               Make the current word available for compilation.

		$COLON  IMEDD+7,'RECURSE',RECUR
		CALL    LAST
		CALL    AT
		CALL    NAMET
		CALL    CALLC
		RET

;; Structures

;   FOR         ( -- a )
;               Start a FOR-NEXT loop structure in a colon definition.

		$COLON  IMEDD+3,'FOR',FORR
		CALL    COMPI
		CALL    TOR
		CALL    HERE
		RET

;   BEGIN       ( -- a )
;               Start an infinite or indefinite loop structure.

		$COLON  IMEDD+5,'BEGIN',BEGIN
		CALL    HERE
		RET

;   NEXT        ( a -- )
;               Terminate a FOR-NEXT loop structure.

		$COLON  IMEDD+4,'NEXT',NEXT
		CALL    COMPI
		CALL    DONXT
		CALL    COMMA
		RET

;   UNTIL       ( a -- )
;               Terminate a BEGIN-UNTIL indefinite loop structure.

		$COLON  IMEDD+5,'UNTIL',UNTIL
		CALL    COMPI
		CALL    QBRAN
		CALL    COMMA
		RET

;   AGAIN       ( a -- )
;               Terminate a BEGIN-AGAIN infinite loop structure.

		$COLON  IMEDD+5,'AGAIN',AGAIN
		CALL    COMPI
		CALL     BRAN
		CALL    COMMA
		RET

;   IF          ( -- A )
;               Begin a conditional branch structure.

		$COLON  IMEDD+2,'IF',IFF
		CALL    COMPI
		CALL    QBRAN
		CALL    HERE
		CALL    ZERO
		CALL    COMMA
		RET

;   AHEAD       ( -- A )
;               Compile a forward branch instruction.

		$COLON  IMEDD+5,'AHEAD',AHEAD
		CALL    COMPI
		CALL    BRAN
		CALL    HERE
		CALL    ZERO
		CALL    COMMA
		RET

;   REPEAT      ( A a -- )
;               Terminate a BEGIN-WHILE-REPEAT indefinite loop.

		$COLON  IMEDD+6,'REPEAT',REPEA
		CALL    AGAIN
		CALL    HERE
		CALL    SWAP
		CALL    STORE
		RET

;   THEN        ( A -- )
;               Terminate a conditional branch structure.

		$COLON  IMEDD+4,'THEN',THENN
		CALL    HERE
		CALL    SWAP
		CALL    STORE
		RET

;   AFT         ( a -- a A )
;               Jump to THEN in a FOR-AFT-THEN-NEXT loop the first time through.

		$COLON  IMEDD+3,'AFT',AFT
		CALL    DROP
		CALL    AHEAD
		CALL    BEGIN
		CALL    SWAP
		RET

;   ELSE        ( A -- A )
;               Start the false clause in an IF-ELSE-THEN structure.

		$COLON  IMEDD+4,'ELSE',ELSEE
		CALL    AHEAD
		CALL    SWAP
		CALL    THENN
		RET

;   WHILE       ( a -- A a )
;               Conditional branch out of a BEGIN-WHILE-REPEAT loop.

		$COLON  IMEDD+5,'WHILE',WHIL
		CALL    IFF
		CALL    SWAP
		RET

;   ABORT"	( -- ; <string> )
;               Conditional abort with an error message.

		$COLON  IMEDD+6,'ABORT"',ABRTQ
		CALL    COMPI
		CALL    ABORQ
		CALL    STRCQ
		RET

;   Z"		( -- ; <string> )
;               Compile an inline string literal.

		$COLON  IMEDD+2,'Z"',ZSTRQ
		CALL    COMPI
		CALL    ZQP
		CALL    STRCQ
		RET


;   $"		( -- ; <string> )
;               Compile an inline string literal.

		$COLON  IMEDD+2,'$"',STRQ
		CALL    COMPI
		CALL    STRQP
		CALL    STRCQ
		RET



;   ."		( -- ; <string> )
;               Compile an inline string literal to be typed out at run time.

		$COLON  IMEDD+2,'."',DOTQ
		CALL    COMPI
		CALL    DOTQP
		CALL    STRCQ
		RET

;; Name compiler

;   ?UNIQUE     ( a -- a )
;               Display a warning message if the word already exists.

		$COLON  7,'?UNIQUE',UNIQU
		CALL    DUPP

		CALL    ZERO
		CALL    CAP                ; turn off cap
		CALL    DUPP
		CALL    AT
		CALL    TOR
		CALL    STORE
		
		CALL    NAMEQ                   ;?name exists
		
		CALL    RFROM
		CALL    CAP
		CALL    STORE              ; restore cap


		$QBRAN	UNIQ1                   ;redefinitions are OK
		D$      DOTQP,' reDef '         ;but warn the user
		CALL    OVER
		CALL    COUNT
		CALL    TYPEE                   ;just in case its not planned
UNIQ1:          CALL    DROP
		RET

;   $,n         ( na -- )
;               Build a new dictionary name using the string at na.

		$COLON  3,'$,n',SNAME
		CALL    DUPP
		CALL    CAT       ;?null input
		$QBRAN	PNAM1
		CALL    UNIQU     ;?redefinition
		CALL    DUPP	  ; na na --
		CALL    LAST
		CALL    STORE     ;save na for vocabulary link
		CALL    CELLM     ; link-address --
		CALL    CRRNT
		CALL    AT
		CALL    AT
		CALL    OVER	  ; la current@@ la --
		CALL    STORE	  ; la --
		CALL	CELLP	  ; na --
		CALL	COUNT
		CALL	PLUS	  ; ca --
		CALL    ONEP      ; skip NULL terminator 
		CALL    CP
		CALL    STORE     ;adjust name pointer
;		CALL    STORE
		RET              ;save code pointer
PNAM1:
        D$      STRQP,' name'           ;null input
		CALL    DROP
		CALL    ONEM

		CALL    THROW

;; FORTH compiler

;   $COMPILE    ( a -- )
;               Compile next word to code dictionary as a token or literal.

		$COLON  8,'$COMPILE',SCOMP
		CALL    NAMEQ
		CALL    QDUP              ;?defined
		$QBRAN	SCOM2
		CALL    AT
		CALL    DOLIT
		DD	IMEDD
		CALL    ANDD			;?immediate
		$QBRAN	SCOM1
		CALL    EXECU
		RET              ;its immediate, execute
SCOM1:          CALL    CALLC
		RET              ;its not immediate, compile
SCOM2:          CALL    TNUMB
		CALL    ATEXE             ;try to convert to number
		$QBRAN	SCOM3
		CALL    LITER
		RET              ;compile number as integer
SCOM3:          CALL    THROW                   ;error

;   OVERT       ( -- )
;               Link a new word into the current vocabulary.

		$COLON  5,'OVERT',OVERT
		CALL    LAST
		CALL    AT
		CALL    CRRNT
		CALL    AT
		CALL    STORE
		RET

;   ;           ( -- )
;               Terminate a colon definition.

		$COLON  IMEDD+1,';',SEMIS
		CALL    DOLIT
		DD	RETT
		CALL    CCOMMA
		CALL    LBRAC
		CALL    OVERT
		RET

;   ]           ( -- )
;               Start compiling the words in the input stream.

		$COLON  1,']',RBRAC
		CALL    DOLIT
		DD	SCOMP
		CALL    TEVAL
		CALL    STORE
		RET

;   call,       ( ca -- )
;               Assemble a call instruction to ca.

		$COLON  5,'call,',CALLC
		CALL    DOLIT
		DD	CALLL
		CALL    CCOMMA	;subroutine threaded code
		CALL    HERE
		CALL    CELLP
		CALL    SUBB
		CALL    COMMA   ; 80x86 relative call
		RET

;   :           ( -- ; <string> )
;               Start a new colon definition using next word as its name.

		$COLON  1,':',COLON
		CALL    TOKEN
		CALL    SNAME
		CALL    RBRAC

		RET

;   IMMEDIATE   ( -- )
;               Make the last compiled word an immediate word.

		$COLON  9,'IMMEDIATE',IMMED
		CALL    DOLIT
		DD	IMEDD
		CALL    LAST
		CALL    AT
		CALL    AT
		CALL    ORR
		CALL    LAST
		CALL    AT
		CALL    STORE
		RET

;; Defining words

;   USER        ( u -- ; <string> )
;               Compile a new user variable.

		$COLON  4,'USER',USER
		CALL    TOKEN
		CALL    SNAME
		CALL    OVERT
		CALL    COMPI
		CALL    DOUSE
		CALL    COMMA
		RET

;   CREATE      ( -- ; <string> )
;               Compile a new array entry without allocating code space.

		$COLON  6,'CREATE',CREAT
		CALL    TOKEN
		CALL    SNAME
		CALL    OVERT
		CALL    COMPI
		CALL    DOVAR
		RET

;   VARIABLE    ( -- ; <string> )
;               Compile a new variable initialized to 0.

		$COLON  8,'VARIABLE',VARIA
		CALL    CREAT
		CALL    ZERO
		CALL    COMMA
		RET

;; Tools

;   _TYPE       ( b u -- )
;               Display a string. Filter non-printing characters.

		$COLON  5,'_TYPE',UTYPE_
		CALL    TOR                     ;start count down loop
		$BRAN	UTYP2              ;skip first pass
UTYP1:          CALL    DUPP
		CALL    CAT
		CALL    T_CHAR
		CALL    EMIT     ;display only printable
		CALL    ONEP
UTYP2:          CALL    DONXT
		DD	UTYP1             ;loop till done
		CALL    DROP
		RET

;   dm+         ( a u -- a )
;               Dump u bytes from , leaving a+u on the stack.

		$COLON  3,'dm+',DMP
		CALL    OVER
		CALL    DOLIT
		DD	4
		CALL    UDOTR      ;display address
		CALL    SPACE
		CALL    TOR               ;start count down loop
		$BRAN	PDUM2              ;skip first pass
PDUM1:          CALL    DUPP
		CALL    CAT
		CALL    DOLIT
		DD	3
		CALL    UDOTR  ;display numeric data
		CALL    ONEP
PDUM2:          CALL    DONXT
		DD	PDUM1             ;loop till done
		RET

;   DUMP        ( a u -- )
;               Dump u bytes from a, in a formatted manner.

		$COLON  4,'DUMP',DUMP
		CALL    BASE
		CALL    AT
		CALL    TOR
		CALL    HEX         ;save radix, set hex
		CALL    DOLIT
		DD	16
		CALL    SLASH          ;change count to lines
		CALL    TOR
		$BRAN	DUMP4          ;start count down loop
DUMP1:          CALL    CR
		CALL    DOLIT
		DD	16
		CALL    DDUP
		CALL    DMP    ;display numeric
		CALL    ROT
		CALL    ROT
		CALL    SPACE
		CALL    SPACE
		CALL    UTYPE_       ;display printable characters
		CALL    NUFQ
		CALL    INVER              ;user control
		$QBRAN	DUMP2
DUMP4:          CALL    DONXT
		DD	DUMP1             ;loop till done
		$BRAN	DUMP3
DUMP2:          CALL    RFROM
		CALL    DROP              ;cleanup loop stack, early exit
DUMP3:          CALL    DROP
		CALL    RFROM
		CALL    BASE
		CALL    STORE   ;restore radix
		RET

;   .S          ( ... -- ... )
;               Display the contents of the data stack.

		$COLON  2,'.S',DOTS
		CALL    SPACE
		CALL    DEPTH             ;stack depth
		CALL    TOR                     ;start count down loop
		$BRAN	DOTS2              ;skip first pass
DOTS1:          CALL    RAT
		CALL    PICK
		CALL    DOT            ;index stack, display contents
DOTS2:          CALL    DONXT
		DD	DOTS1             ;loop till done
		CALL    SPACE
		RET

;   !CSP        ( -- )
;               Save stack pointer in CSP for error checking.

		$COLON  4,'!CSP',STCSP
		CALL    SPAT
		CALL    CSP
		CALL    STORE
		RET     ;save pointer

;   ?CSP        ( -- )
;               Abort if stack pointer differs from that saved in CSP.

		$COLON  4,'?CSP',QCSP
		CALL    SPAT
		CALL    CSP
		CALL    AT
		CALL    XORR        ;compare pointers
		D$      ABORQ,'stacks'          ;abort if different
		RET

;   >NAME       ( ca -- na | F )
;               Convert code address to a name address.

		$COLON  5,'>NAME',TNAME
		CALL    CRRNT                   ;vocabulary link
TNAM1:          CALL    CELLP
		CALL    AT
		CALL    QDUP           ;check all vocabularies
		$QBRAN	TNAM4
		CALL    DDUP
TNAM2:          CALL    AT
		CALL    DUPP                 ;?last word in a vocabulary
		$QBRAN	TNAM3
		CALL    DDUP
		CALL    NAMET
		CALL    XORR         ;compare
		$QBRAN	TNAM3
		CALL    CELLM                   ;continue with next word
		$BRAN	TNAM2
TNAM3:          CALL    SWAP
		CALL    DROP
		CALL    QDUP
		$QBRAN	TNAM1
		CALL    SWAP
		CALL    DROP
		CALL    SWAP
		CALL    DROP
		RET
TNAM4:          CALL    DROP
		CALL    ZERO
		RET       ;false flag

;   .ID         ( na -- )
;               Display the name at address.

		$COLON  3,'.ID',DOTID
		CALL    QDUP                    ;if zero no name
		$QBRAN	DOTI1
		CALL    COUNT
		CALL    DOLIT
		DD	01FH
		CALL    ANDD 			        ;mask lexicon bits
		CALL    TYPEE                   ;display name string, TYPE is faster than UTYPE
		RET             
DOTI1:          D$      DOTQP,' {noName}'
		RET

;   SEE         ( -- ; <string> )
;               A simple decompiler.

		$COLON  3,'SEE',SEE
		CALL    TICK    ;starting address a
		CALL    CR
SEE0:		CALL	DOLIT
		DD	40
		CALL	TOR
SEE1:           CALL    COUNT	; a+1 byte --
		CALL    DUPP
		CALL	DOLIT
		DD	CALLL	; subroutine call?
		CALL	EQUAL
		$QBRAN	SEE3
		CALL	DROP
		CALL	DUPP
		CALL	AT
		CALL	OVER
		CALL	CELLP
		CALL	PLUS
		CALL    TNAME                   ;?is it a name
		CALL    QDUP                    ;name address or zero
		$QBRAN	SEE2
		CALL    SPACE
		CALL    DOTID             ;display name
		CALL	CELLP
		$BRAN	SEE4
SEE2:		CALL	COUNT		
SEE3:           CALL    DOT            ;display number
SEE4:           CALL    DONXT
		DD	SEE1
		CALL	KEY
		CALL	DOLIT
		DD	32
		CALL	XORR
		$QBRAN	SEE0
		JMP    DROP

;   WORDS       ( -- )
;               Display the names in the context vocabulary.

		$COLON  5,'WORDS',WORDS
		CALL    CR
		CALL    CNTXT
		CALL    AT             ;only in context
WORS1:          CALL    AT
		CALL    QDUP                 ;?at end of list
		$QBRAN	WORS2
		CALL    DUPP
		CALL    SPACE
		CALL    DOTID        ;display a name
		CALL    CELLM
		CALL    NUFQ              ;user control
		$QBRAN	WORS1
		CALL    DROP
WORS2:          RET

;; Hardware reset

;   VER         ( -- n )
;               Return the version number of this implementation.

		$COLON  3,'VER',VERSN
		CALL    DOLIT
		DD	VER*256+EXT
		RET

;   hi          ( -- )
;               Display the sign-on message of eForth.

		$COLON  2,'hi',HI
		CALL    STOIO
		CALL    CR                ;initialize I/O
		D$      DOTQP,'WeForth v'    ;model
		CALL    BASE
		CALL    AT
		CALL    HEX             ;save radix
		CALL    VERSN
		CALL    BDIGS
		CALL    DIG
		CALL    DIG
		CALL    DOLIT
		DD	'.'
		CALL    HOLD
		CALL    DIGS
		CALL    EDIGS
		CALL    TYPEE        ;format version number
		CALL    BASE
		CALL    STORE
		JMP    CR
;		RET      ;restore radix

;   'BOOT       ( -- a )
;               The application startup vector.

		$COLON  5,"'BOOT",TBOOT
		CALL    DOVAR
		dd    HI                      ;application to boot

	$COLON	8,'DIAGNOSE',DIAGNOSE    
		CALL	DOLIT
		DD	65H	;e
		CALL	EMIT
		CALL	ZERO
		CALL	ZLESS
		CALL	DOLIT
		DD	-2
		CALL	ZLESS
		CALL	UPLUS
		CALL	DOLIT
		DD	3
		CALL	UPLUS
		CALL	UPLUS
		CALL	DROP
		CALL	DOLIT
		DD	43H
		CALL 	UPLUS
		CALL	DROP
		CALL	EMIT	;F
		CALL	DOLIT
		DD	4FH
		CALL	DOLIT
		DD	6FH
		CALL	XORR
		CALL	DOLIT
		DD	0F0H
		CALL	ANDD
		CALL	DOLIT
		DD	4FH
		CALL	ORR
		CALL	EMIT	; o
		CALL	DOLIT
		DD	8
		CALL	DOLIT
		DD	6
		CALL	SWAP
		CALL	OVER
		CALL	XORR
		CALL	DOLIT
		DD	3
		CALL	ANDD
		CALL	ANDD
		CALL	DOLIT
		DD	70H
		CALL	UPLUS
		CALL	DROP
		CALL	EMIT	; r
		CALL	ZERO
		$QBRAN	DIAG1
		CALL	DOLIT
		DD	3FH
DIAG1:		CALL	DOLIT
		DD	-1
		$QBRAN	DIAG2
		CALL	DOLIT
		DD	74H
		$BRAN	DIAG3
DIAG2:		CALL	DOLIT
		DD	21H
DIAG3:		CALL	EMIT	; t
		CALL	DOLIT
		DD	68H
		CALL	DOLIT
		DD	UZERO
		CALL	STORE
		CALL	DOLIT
		DD	UZERO
		CALL	AT
		CALL	EMIT	; h
		CALL	DOLIT
		DD	4FH
		CALL	TOR
		CALL	RAT
		CALL	RFROM
		CALL	ANDD
		CALL	EMIT	; O
		CALL	DOLIT
		DD	40H
		CALL	DOLIT
		DD	0AH
		CALL	TOR
DIAG4:		CALL	DOLIT
		DD	1
		CALL	UPLUS
		CALL	DROP
		CALL	DONXT
		DD	DIAG4
		CALL	EMIT	; K
		RET

;Display relevant registers for debugging.

;REGS:           
;		CALL    CRLF 
;		MOV     EAX,EBX
;		CALL    HEX4
;		MOV     EAX,[EBP]
;		CALL    HEX4
;		MOV     EAX,4[EBP]
;		CALL    HEX4
;		MOV     EAX,8[EBP]
;		CALL    HEX4
;		CALL	KEY
;		CALL	DROP
;		RET

;   COLD        ( -- )
;               The hilevel cold start sequence.

		$COLON  4,'COLD',COLD
COLD1:          CALL    DIAGNOSE    

		CALL    DOLIT
		DD      UZERO
		CALL    DOLIT
		DD      UPP
		CALL    DOLIT
		DD      ULAST-UZERO
		CALL    CMOVEE ;initialize user area
		CALL    PRESE                   ;initialize stack and TIB
		CALL    TBOOT
		CALL    ATEXE                   ;application boot
		CALL    FORTH
		CALL    CNTXT
		CALL    AT
		CALL    DUPP     ;initialize search order
		CALL    CRRNT
		CALL    DSTOR
		CALL    OVERT

        CALL    DOLIT
		DD      startupfile
        CALL    DOFLOAD                ; call default load file                

		CALL    QUIT                    ;start interpretation
		$BRAN	COLD1                   ;just in case


;Tools to debug code in protected mode in which DEBUG and CodeView
;do not work.  STEPS must be called inside $NEXT.  REGS can be called
;anywhere inside code words, most likely in doLIST.

;Stepping through kernel words for debugging.       

; STEPS:          CALL    REGS
;		RET

		
;Display registers for debugging purposes

;CRLF:           CALL	DOLIT
;		DD      0DH
;		CALL    EMIT
;		RET

;HEX4:           PUSH    EAX
;		MOV     EAX,20H
;		invoke HostEmit,eax
;		POP     EAX

;		PUSH    EAX
;		SHR     EAX,16
;		CALL    HEX2
;		POP     EAX

;HEX2:           PUSH    EAX
;		SHR     EAX,8
;		CALL    HEX1
;		POP     EAX

;HEX1:           PUSH    EAX
;		SHR     EAX,4
;		CALL    HEX0
;		POP     EAX
;
;HEX0:           AND     EAX,0FH
;		ADD     EAX,'0'
;		CMP     EAX,'9'
;		JBE     SHORT OUTCH
;		ADD     EAX,'A'-'0'-0AH

;OUTCH:          invoke HostEmit,eax
;		RET

;===============================================================

LASTN           EQU     _LINK                 ;last name address
CTOP            EQU     $                     ;next available memory in code dictionary

;===============================================================


;==========================================================END OF EF502==============================================

db 20000H dup(0)
DICTEND:

;COLD0:
;again0:
;  call KEY
;  cmp ebx,27
;  je Exit
;  call DUPP
;  call EMIT
;  call EMIT
;  jmp again0
;Exit:
;  ret      
;====================================================================
end start
