ANEW <<dbg.f>> \ the step debuger 24feb02 ~ 04apr02 SamChen

  CREATE bp_image $90 ALLOT  bp_image 90 ERASE
  HERE CONSTANT bp_limit

  bp_image VALUE bp_entry

  DEFER (debug)

: clear_bp bp_image DUP ( p p ) DUP TO bp_entry
  BEGIN  ( p p' ) DUP @  ?DUP 
  WHILE  ( p p' a ) OVER CELL+ SWAP 5 ( p' p'+4 a 5 ) CMOVE 9 +
  REPEAT ( p p" ) OVER - ERASE ;
cr
: .s BASE @ >R HEX DEPTH DUP 0< 
  IF ." underflow, auto preset" PRESET 0
  THEN ?DUP
  IF 1-
     FOR R@ PICK ."  $" 0 .R
     NEXT
  ELSE ."  empty"
  THEN R> BASE ! ; 

: step_debuger
\ reg!                \ save all flags and registers into reg buffer
  clear_bp            \ recOVER code image
  R> BODY>            \ get break point ( v1 v2 curr_pc )
  >R                  \ make sure current instruction be executed
\ CELL reg $E + +!    \ adjust rp value in reg buffer
\ reg.                \ show all flags and registers
  CR .s R@ dis1          \ show data stack and current instruction
  next_pc !           \ save pc for next instruction
  BEGIN
\    bp
     KEY
     DUP $1B =        \ see IF the key is ESC
     IF 0 TO step_depth ABORT" abort from dbg"
     THEN DUP BL =  
     OVER ASCII f = OR  OVER ASCII u = OR  OVER ASCII n = OR
     OVER ASCII F = OR  OVER ASCII U = OR  OVER ASCII N = OR  NOT
  WHILE CR .s DROP ." ? f=query u=unnest n=nest SPACE=next ESC=abort ELSE=help"
  REPEAT ( key )
  DUP ASCII f = OVER ASCII F = OR
  IF DROP $" dbg> "
     query_loop       \ get into query_execute loop
\    reg@             \ ignore data remained on stack WHILE return from loop
     EXIT
  THEN 
  DUP ASCII n = OVER ASCII N = OR  \ nest into a word
  IF R@ C@  DUP $E8 =  SWAP $E9 =  branch_target @ branch_ca @ =  AND  OR
     \ make sure it's a call or last jump instruction
     IF 1 +TO step_depth
        DROP R@
        @CurRelAddr   \ get the code address to call
        (debug) EXIT  \ nest TO the word called
     THEN
  THEN 
  DUP ASCII u = OVER ASCII U = OR
  branch_target @ DUP branch_ca @ = AND OR
  R@ C@ $C3 =  OR     \ unnest to caller
  IF DROP step_depth 
     IF -1 +TO step_depth
        RP@ CELL+ @   \ get address on return stack for returning to caller
       (debug)        \ unnest from curr word, return to caller
     THEN EXIT        
  THEN                
  DROP                \ otherwise stepwise TO the next instruction
  branch_target @ ?DUP
  IF ( ... v2 v1 ta ) (debug) 
  THEN ( ... v2 v1 )
  next_pc @ ?DUP
  IF (debug)
  THEN ;

: set_breakpoint ( a -- ) \ set break point
  bp_entry DUP bp_limit < NOT ABORT" cannot set too many break points"
  2DUP ! ( a bpe ) 2DUP CELL+ 5 CMOVE ( a bpe ) $9 + TO bp_entry
  $E8 OVER C! ( a ) 1+ ( a+1 )
  ['] step_debuger OVER CELL+ - SWAP ! ;

' set_breakpoint IS (debug)

: debug ' (debug) ; \ set break point at BEGINning of given word

: dbg ' dup code_start !  dup code_limit !
  DUP (debug) EXECUTE ; \ debug the given word

\ : xxx IF ." true" ELSE ." flase" THEN ;
\ 1 dbg xxx

