ANEW WEEDITOR
\ ================================= The Editor  ===========================
\
\ To Edit a exising file , type "EDIT filename" in console
\ if filename is not supplied , EDIT will open a dialog for you to choose
\ a file, press cancel in the open file dialog to edit a new file
\ the name of new file will be Edit1, Edit2, Edit3 and so on
\ To save a file, Press F2
\ To save as a new name , Press F3
\ Saving a non existing file ( like Edit1 ) is indentical to "Save As"
\ Improvement:
\   .Goto Line
\   .Find/replace

 \ press F11 and F12 to switch between multiple EDIT window
\ press F9 to switch back and forth to console window
\ to compile a editing line ( where the caret locate) press F6
\ to compile the whole editing file press F7 , 
\ you don't have to save file before compilation.
\ 
\ F6 and F7 use BLOAD ( compile memory buffer) to compile the content of editor.
\ F8 use FLOAD to compile the saved file.
\ F6 ,F7, F8 run in Window callback context, datastack will be reset after execution.


1 1 + .      ( Press F6 To compile this line )
1 2 + .      ( Press F7 To compile the whole file )

\ Handle of Editors' window is maintain by a circular single linked list
\ the newly open editor handle is stored in variable lasteditor
\ the edit box in focus is stored in THISEDIT 
\ the current editor handle is stored in hWnd
\ LINK> to get the previous windows
\ >LINK to get the next editor
\ examples:

THISEDIT ?              ( handle of this edit box )
hWnd ?                  ( handle of this editor )
hwnd @ LINK> .          ( handle of previous window )
hWnd @ >LINK .          ( handle of next window )


\ ================================= The Console ===========================
\ paste text in console window will execute immediately
\ the handle of console window is stored in a constant HWND
\ the edit box of console is stored in constant HCONSOLE

\ Adjust Consolue windows position 

HWND 10 10 250 250 -1 MoveWindow DROP

\ Use sendMessageA to communicate with Console, for example 
\ to change the caption of CONSOLE, 

: changecaption HWND WM_SETTEXT 0 Z" Hi! WeForth is Cool!" SendMessageA DROP ; changecaption

\ you can do almost everything by using SendMessageA
\ Enjoy Windows programming with WeForth !
